/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

var _typeof = require('./dep-bbe52a2d.js');
var eq = require('./dep-d788c41a.js');
var isArrayLike = require('./dep-f8271f08.js');
var _isIndex = require('./dep-5267fa9b.js');
var isObject = require('./dep-3561ed02.js');

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject.isObject(object)) {
    return false;
  }
  var type = _typeof._typeof(index);
  if (type == 'number' ? isArrayLike.isArrayLike(object) && _isIndex.isIndex(index, object.length) : type == 'string' && index in object) {
    return eq.eq(object[index], value);
  }
  return false;
}

exports.isIterateeCall = isIterateeCall;
//# sourceMappingURL=dep-1f99f0e5.js.map
