/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

var _typeof = require('./dep-bbe52a2d.js');
var _baseGetTag = require('./dep-7ffe7abb.js');
var isObjectLike = require('./dep-53bbe417.js');

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return _typeof._typeof(value) == 'symbol' || isObjectLike.isObjectLike(value) && _baseGetTag.baseGetTag(value) == symbolTag;
}

exports.isSymbol = isSymbol;
//# sourceMappingURL=dep-7e859ab6.js.map
