/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useControlled = require('../hooks/useControlled.js');
var autoComplete_defaultProps = require('./defaultProps.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var input_index = require('../input/index.js');
var popup_index = require('../popup/index.js');
var autoComplete_OptionList = require('./OptionList.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-228d2001.js');
require('../_util/noop.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7e859ab6.js');
require('../_chunks/dep-53bbe417.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../input/Input.js');
require('../_chunks/dep-2a791a26.js');
require('tdesign-icons-react');
require('../hooks/useLayoutEffect.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../hooks/useGlobalIcon.js');
require('../input/InputGroup.js');
require('../input/defaultProps.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-53ae9438.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-dd0b0216.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useAnimation.js');
require('../common/Portal.js');
require('react-dom');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../_chunks/dep-dfd3a819.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var AutoComplete = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var _props$placeholder;
  var props = hooks_useDefaultProps["default"](originalProps, autoComplete_defaultProps.autoCompleteDefaultProps);
  var inputRef = React.useRef(null);
  var popupRef = React.useRef(null);
  var _useControlled = hooks_useControlled["default"](props, "value", props.onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    tValue = _useControlled2[0],
    setTValue = _useControlled2[1];
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    classPrefix = _useCommonClassName.classPrefix,
    sizeClassNames = _useCommonClassName.sizeClassNames;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("input"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 1),
    global = _useLocaleReceiver2[0];
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    popupVisible = _useState2[0],
    setPopupVisible = _useState2[1];
  var optionListRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      inputRef: inputRef.current,
      popupRef: popupRef.current
    };
  });
  var getOverlayStyle = function getOverlayStyle(trigger, popupElement) {
    var _props$popupProps;
    var triggerWidth = trigger.getBoundingClientRect().width || trigger.offsetWidth || trigger.clientWidth;
    var popupWidth = popupElement.getBoundingClientRect().width || popupElement.offsetWidth || popupElement.clientWidth;
    return _objectSpread({
      width: triggerWidth >= popupWidth ? "".concat(triggerWidth, "px") : "auto"
    }, (_props$popupProps = props.popupProps) === null || _props$popupProps === void 0 ? void 0 : _props$popupProps.overlayInnerStyle);
  };
  var classes = ["".concat(classPrefix, "-auto-complete")].concat(props.className);
  var popupClasses = function (_props$popupProps2) {
    var classes2 = ["".concat(classPrefix, "-select__dropdown")];
    if ((_props$popupProps2 = props.popupProps) !== null && _props$popupProps2 !== void 0 && _props$popupProps2.overlayClassName) {
      classes2 = classes2.concat(props.popupProps.overlayClassName);
    }
    return classNames__default["default"](classes2);
  }();
  var popupInnerClasses = function (_props$popupProps3) {
    var classes2 = ["".concat(classPrefix, "-select__dropdown-inner")];
    if ((_props$popupProps3 = props.popupProps) !== null && _props$popupProps3 !== void 0 && _props$popupProps3.overlayInnerClassName) {
      classes2 = classes2.concat(props.popupProps.overlayInnerClassName);
    }
    return classNames__default["default"](classes2);
  }();
  var onInputChange = function onInputChange(value, context) {
    if (!popupVisible) {
      setPopupVisible(true);
    }
    setTValue(value, context);
  };
  var innerInputProps = function () {
    var tProps = _objectSpread({
      value: tValue,
      size: props.size
    }, props.inputProps);
    return tProps;
  }();
  var onInnerFocus = function onInnerFocus(value, context) {
    var _props$onFocus;
    setPopupVisible(true);
    (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 || _props$onFocus.call(props, _objectSpread(_objectSpread({}, context), {}, {
      value: value
    }));
    var timer = setTimeout(function () {
      var _optionListRef$curren;
      (_optionListRef$curren = optionListRef.current) === null || _optionListRef$curren === void 0 || _optionListRef$curren.addKeyboardListener();
      clearTimeout(timer);
    }, 0);
  };
  var onInnerBlur = function onInnerBlur(value, context) {
    var _props$onBlur;
    (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 || _props$onBlur.call(props, _objectSpread(_objectSpread({}, context), {}, {
      value: value
    }));
  };
  var onInnerEnter = function onInnerEnter(value, context) {
    var _props$onEnter;
    (_props$onEnter = props.onEnter) === null || _props$onEnter === void 0 || _props$onEnter.call(props, _objectSpread(_objectSpread({}, context), {}, {
      value: value
    }));
  };
  var onInnerCompositionend = function onInnerCompositionend(value, context) {
    var _props$onCompositione;
    (_props$onCompositione = props.onCompositionend) === null || _props$onCompositione === void 0 || _props$onCompositione.call(props, _objectSpread(_objectSpread({}, context), {}, {
      value: value
    }));
  };
  var onInnerCompositionstart = function onInnerCompositionstart(value, context) {
    var _props$onCompositions;
    (_props$onCompositions = props.onCompositionstart) === null || _props$onCompositions === void 0 || _props$onCompositions.call(props, _objectSpread(_objectSpread({}, context), {}, {
      value: value
    }));
  };
  var onInnerSelect = function onInnerSelect(value, context) {
    var _props$onSelect;
    if (props.readonly || props.disabled) return;
    setPopupVisible(false);
    setTValue(value, context);
    (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 || _props$onSelect.call(props, value, context);
  };
  var onPopupVisibleChange = function onPopupVisibleChange(visible, _ref) {
    var trigger = _ref.trigger;
    if (trigger !== "trigger-element-click") {
      setPopupVisible(visible);
    }
  };
  var triggerNode = props.triggerElement || props.children || /* @__PURE__ */React__default["default"].createElement(input_index.Input, _objectSpread({
    ref: inputRef,
    placeholder: (_props$placeholder = props.placeholder) !== null && _props$placeholder !== void 0 ? _props$placeholder : global.placeholder,
    tips: props.tips,
    status: props.status,
    readonly: props.readonly,
    disabled: props.disabled,
    clearable: props.clearable,
    autofocus: props.autofocus,
    borderless: props.borderless,
    onClear: props.onClear,
    onChange: onInputChange,
    onFocus: onInnerFocus,
    onBlur: onInnerBlur,
    onEnter: onInnerEnter,
    onCompositionend: onInnerCompositionend,
    onCompositionstart: onInnerCompositionstart
  }, innerInputProps));
  var listContent = Array.isArray(props.options) && /* @__PURE__ */React__default["default"].createElement(autoComplete_OptionList["default"], {
    ref: optionListRef,
    value: tValue,
    options: props.options,
    size: props.size,
    sizeClassNames: sizeClassNames,
    onSelect: onInnerSelect,
    popupVisible: popupVisible,
    highlightKeyword: props.highlightKeyword,
    filterable: props.filterable,
    filter: props.filter,
    empty: props.empty
  });
  var topContent = props.panelTopContent;
  var bottomContent = props.panelBottomContent;
  var panelContent = topContent || listContent || bottomContent ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-auto-complete__panel")
  }, topContent, listContent, bottomContent) : null;
  var popupProps = _objectSpread(_objectSpread({}, props.popupProps), {}, {
    overlayInnerStyle: getOverlayStyle,
    overlayInnerClassName: popupInnerClasses,
    overlayClassName: popupClasses
  });
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](classes),
    style: props.style
  }, /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread({
    ref: popupRef,
    visible: popupVisible,
    onVisibleChange: onPopupVisibleChange,
    trigger: "focus",
    placement: "bottom-left",
    hideEmptyPopup: true,
    content: panelContent
  }, popupProps), triggerNode));
});
AutoComplete.displayName = "AutoComplete";

exports["default"] = AutoComplete;
//# sourceMappingURL=AutoComplete.js.map
