/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-a21132eb.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var log = require('../_chunks/dep-53ae9438.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var breadcrumb_BreadcrumbItem = require('./BreadcrumbItem.js');
var breadcrumb_BreadcrumbContext = require('./BreadcrumbContext.js');
var breadcrumb_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var isFunction = require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-bbe52a2d.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('hoist-non-react-statics');
require('../_chunks/dep-3949d9f0.js');
require('../hooks/useGlobalIcon.js');
require('../hooks/useCommonClassName.js');
require('../_util/parseTNode.js');
require('../tooltip/index.js');
require('../tooltip/Tooltip.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/useAnimation.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-6539e3d4.js');
require('../_util/scroll.js');
require('raf');
require('../_util/easing.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["children", "options", "separator", "maxItemWidth", "className", "maxItems", "itemsAfterCollapse", "itemsBeforeCollapse", "ellipsis"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Breadcrumb = _util_forwardRefWithStatics["default"](function (props, ref) {
  var _useDefaultProps = hooks_useDefaultProps["default"](props, breadcrumb_defaultProps.breadcrumbDefaultProps),
    children = _useDefaultProps.children,
    options = _useDefaultProps.options,
    separator = _useDefaultProps.separator,
    maxItemWidth = _useDefaultProps.maxItemWidth,
    className = _useDefaultProps.className,
    maxItems = _useDefaultProps.maxItems,
    itemsAfterCollapse = _useDefaultProps.itemsAfterCollapse,
    itemsBeforeCollapse = _useDefaultProps.itemsBeforeCollapse,
    ellipsis = _useDefaultProps.ellipsis,
    restProps = objectWithoutProperties._objectWithoutProperties(_useDefaultProps, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var renderOptionsToItems = React.useCallback(function (options2) {
    if (!options2 || !options2.length) {
      return void 0;
    }
    return options2.map(function (option, index) {
      var targetProps = {};
      if (option.target) {
        targetProps.target = option.target;
      }
      return /* @__PURE__ */React__default["default"].createElement(breadcrumb_BreadcrumbItem["default"], _objectSpread(_objectSpread({}, targetProps), {}, {
        key: index,
        maxWidth: option.maxWidth,
        disabled: option.disabled,
        href: option.href,
        to: option.to,
        router: option.router,
        replace: option.replace,
        separator: separator,
        maxItemWidth: maxItemWidth,
        icon: option.icon,
        content: option.content
      }), option.content || option.children);
    });
  }, [maxItemWidth, separator]);
  var renderEllipsis = React.useCallback(function (items) {
    if (!ellipsis) {
      return /* @__PURE__ */React__default["default"].createElement(tdesignIconsReact.EllipsisIcon, null);
    }
    if (isFunction.isFunction(ellipsis)) {
      return ellipsis({
        items: items,
        separator: separator
      });
    }
    return ellipsis;
  }, [ellipsis, separator]);
  var content = React.useMemo(function () {
    var _items;
    var items = renderOptionsToItems(options) || React.Children.toArray(children);
    var itemsCount = ((_items = items) === null || _items === void 0 ? void 0 : _items.length) || 0;
    if (!items || !maxItems) {
      return items;
    }
    if (maxItems >= itemsCount) {
      return items;
    }
    if (maxItems && (!itemsBeforeCollapse || !itemsAfterCollapse)) {
      log.log.error("Breadcrumb", "\u9700\u8981\u8BBE\u7F6E itemsBeforeCollapse \u548C itemsAfterCollapse \u5C5E\u6027\u6765\u63A7\u5236\u7701\u7565\u53F7\u524D\u540E\u7684\u663E\u793A\u9879\u6570\u3002");
      return items;
    }
    if (maxItems && maxItems < (itemsAfterCollapse || 0) + (itemsBeforeCollapse || 0)) {
      log.log.error("Breadcrumb", "maxItems={".concat(maxItems, "} \u5FC5\u987B\u5927\u4E8E\u6216\u7B49\u4E8E itemsBeforeCollapse={").concat(itemsBeforeCollapse, "} + itemsAfterCollapse={").concat(itemsAfterCollapse, "}"));
      return items;
    }
    var startCount = itemsBeforeCollapse;
    var endCount = itemsAfterCollapse;
    var collapsedItems = items.slice(startCount, itemsCount - endCount);
    var beforeItems = items.slice(0, startCount);
    var afterItems = items.slice(itemsCount - endCount);
    var ellipsis2 = renderEllipsis(collapsedItems.map(function (item) {
      return item.props;
    }));
    items = [].concat(toConsumableArray._toConsumableArray(beforeItems), [/* @__PURE__ */React__default["default"].createElement(breadcrumb_BreadcrumbItem["default"], {
      key: "ellipsis",
      readOnly: true
    }, ellipsis2)], toConsumableArray._toConsumableArray(afterItems));
    return items;
  }, [renderOptionsToItems, options, children, maxItems, itemsBeforeCollapse, itemsAfterCollapse, renderEllipsis]);
  return /* @__PURE__ */React__default["default"].createElement(breadcrumb_BreadcrumbContext.BreadcrumbContext.Provider, {
    value: {
      maxItemWidthInContext: maxItemWidth,
      separator: separator
    }
  }, /* @__PURE__ */React__default["default"].createElement("div", _objectSpread({
    ref: ref,
    className: classNames__default["default"]("".concat(classPrefix, "-breadcrumb"), className)
  }, restProps), content));
}, {
  BreadcrumbItem: breadcrumb_BreadcrumbItem["default"]
});
Breadcrumb.displayName = "Breadcrumb";

exports["default"] = Breadcrumb;
//# sourceMappingURL=Breadcrumb.js.map
