/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var color = require('../../../_chunks/dep-eba0796f.js');
var hooks_useGlobalIcon = require('../../../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../../../hooks/useCommonClassName.js');
require('../../../_chunks/dep-3949d9f0.js');
require('../../../_chunks/dep-228d2001.js');
require('../../../_chunks/dep-3dc69e9b.js');
require('../../../_chunks/dep-fe81c65a.js');
require('../../../_chunks/dep-bbe52a2d.js');
require('tinycolor2');
require('../../../_chunks/dep-50fd1b5a.js');
require('../../../_chunks/dep-54722473.js');
require('../../../_chunks/dep-7ffe7abb.js');
require('../../../_chunks/dep-5bb0ceb3.js');
require('../../../_chunks/dep-53bbe417.js');
require('../../../_chunks/dep-805fcdb5.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-24195208.js');
require('../../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../../_chunks/dep-18f56df7.js');
require('../../../_chunks/dep-db3b17d7.js');
require('../../../_chunks/dep-07098818.js');
require('../../../_chunks/dep-7a979ab0.js');
require('../../../_chunks/dep-f8271f08.js');
require('../../../_chunks/dep-decd1ba5.js');
require('../../../_chunks/dep-3561ed02.js');
require('../../../_chunks/dep-77923495.js');
require('../../../_chunks/dep-5267fa9b.js');
require('../../../_chunks/dep-01c97e2a.js');
require('../../../_chunks/dep-3963da7e.js');
require('../../../_chunks/dep-d788c41a.js');
require('../../../_chunks/dep-a68b527a.js');
require('../../../_chunks/dep-5522bd43.js');
require('../../../_chunks/dep-ad2351bc.js');
require('../../../_chunks/dep-d6f2b851.js');
require('../../../_chunks/dep-40e0109f.js');
require('../../../_chunks/dep-86086537.js');
require('../../../_chunks/dep-1f99f0e5.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var Swatches = function Swatches(props) {
  var baseClassName = props.baseClassName,
    _props$colors = props.colors,
    colors = _props$colors === void 0 ? [] : _props$colors,
    _props$editable = props.editable,
    editable = _props$editable === void 0 ? false : _props$editable,
    title = props.title,
    onChange = props.onChange,
    disabled = props.disabled,
    onSetColor = props.onSetColor,
    handleAddColor = props.handleAddColor;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      DeleteIcon: tdesignIconsReact.DeleteIcon,
      AddIcon: tdesignIconsReact.AddIcon
    }),
    DeleteIcon = _useGlobalIcon.DeleteIcon,
    AddIcon = _useGlobalIcon.AddIcon;
  var swatchesClass = "".concat(baseClassName, "__swatches");
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    statusClassNames = _useCommonClassName.STATUS;
  var isEqualCurrentColor = function isEqualCurrentColor(color$1) {
    return color.Color.compare(color$1, props.color.css);
  };
  var selectedColorIndex = function selectedColorIndex() {
    return colors.findIndex(function (color) {
      return isEqualCurrentColor(color);
    });
  };
  var handleRemoveColor = function handleRemoveColor() {
    var selectedIndex = selectedColorIndex();
    if (selectedIndex > -1) {
      var newColors = colors.filter(function (item, index) {
        return index !== selectedIndex;
      });
      onChange(newColors);
    }
  };
  var handleClick = function handleClick(color) {
    return onSetColor(color);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: swatchesClass
  }, title ? /* @__PURE__ */React__default["default"].createElement("h3", {
    className: "".concat(swatchesClass, "--title")
  }, /* @__PURE__ */React__default["default"].createElement("span", null, title), editable && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(swatchesClass, "--actions")
  }, /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleAddColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(AddIcon, null)), colors.length > 0 ? /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleRemoveColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(DeleteIcon, null)) : null)) : /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(swatchesClass, "--items"), "narrow-scrollbar")
  }, colors.map(function (color) {
    return /* @__PURE__ */React__default["default"].createElement("li", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item"), isEqualCurrentColor(color) && editable ? statusClassNames.active : ""),
      key: color,
      onClick: function onClick() {
        if (disabled) {
          return;
        }
        handleClick(color);
      }
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item__color"), "".concat(baseClassName, "--bg-alpha"))
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(swatchesClass, "--item__inner"),
      style: {
        background: color
      }
    })));
  })));
};
var SwatchesPanel = /*#__PURE__*/React__default["default"].memo(Swatches);

exports["default"] = SwatchesPanel;
//# sourceMappingURL=swatches.js.map
