/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var React = require('react');
var classNames = require('classnames');
var locale_LocalReceiver = require('../../locale/LocalReceiver.js');
var button_index = require('../../button/index.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-228d2001.js');
require('../../config-provider/ConfigProvider.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../../_chunks/dep-f0e94cb0.js');
require('../../_chunks/dep-cd4fa758.js');
require('../../_chunks/dep-cf814f66.js');
require('../../_chunks/dep-7dbe9cf7.js');
require('../../_chunks/dep-bd900d58.js');
require('../../_chunks/dep-e24d1659.js');
require('../../_chunks/dep-df011d17.js');
require('../../button/Button.js');
require('../../_chunks/dep-2a791a26.js');
require('../../hooks/useDomRefCallback.js');
require('../../hooks/useRipple.js');
require('../../_chunks/dep-91f34d3d.js');
require('../../hooks/useAnimation.js');
require('../../_chunks/dep-704d9321.js');
require('../../_chunks/dep-54722473.js');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-b066e7ac.js');
require('../../_chunks/dep-a21132eb.js');
require('../../_chunks/dep-dd0b0216.js');
require('../../loading/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-1c5aedf3.js');
require('../../common/PluginContainer.js');
require('../../button/defaultProps.js');
require('../../_util/parseTNode.js');
require('../../_chunks/dep-53ae9438.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var DatePickerFooter = function DatePickerFooter(props) {
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var confirmText = t(local.confirm);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var enableTimePicker = props.enableTimePicker,
    onConfirmClick = props.onConfirmClick,
    _props$presetsPlaceme = props.presetsPlacement,
    presetsPlacement = _props$presetsPlaceme === void 0 ? "bottom" : _props$presetsPlaceme,
    presets = props.presets,
    onPresetClick = props.onPresetClick,
    selectedValue = props.selectedValue,
    needConfirm = props.needConfirm;
  var footerClass = classNames__default["default"]("".concat(classPrefix, "-date-picker__footer"), "".concat(classPrefix, "-date-picker__footer--").concat(presetsPlacement));
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: footerClass
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-date-picker__presets")
  }, presets && Object.keys(presets).map(function (key) {
    return /* @__PURE__ */React__default["default"].createElement(button_index.Button, {
      key: key,
      size: "small",
      variant: "text",
      onClick: function onClick(e) {
        return onPresetClick(presets[key], {
          e: e,
          preset: defineProperty._defineProperty({}, key, presets[key])
        });
      }
    }, key);
  })), enableTimePicker && needConfirm && /* @__PURE__ */React__default["default"].createElement(button_index.Button, {
    disabled: !selectedValue,
    size: "small",
    theme: "primary",
    onClick: function onClick(e) {
      return onConfirmClick({
        e: e
      });
    }
  }, confirmText));
};
DatePickerFooter.displayName = "DatePickerFooter";

exports["default"] = DatePickerFooter;
//# sourceMappingURL=Footer.js.map
