/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var utils = require('../../_chunks/dep-2a5b1f0c.js');
var locale_LocalReceiver = require('../../locale/LocalReceiver.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-fe81c65a.js');
require('../../_chunks/dep-bbe52a2d.js');
require('dayjs');
require('../../_chunks/dep-737e4f38.js');
require('../../_chunks/dep-4347efab.js');
require('../../_chunks/dep-d5922382.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-c2a15b32.js');
require('../../_chunks/dep-53ae9438.js');
require('../../_chunks/dep-54722473.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-5267fa9b.js');
require('react');
require('../../config-provider/ConfigProvider.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-f0e94cb0.js');
require('../../_chunks/dep-cd4fa758.js');
require('../../_chunks/dep-cf814f66.js');
require('../../_chunks/dep-7dbe9cf7.js');
require('../../_chunks/dep-bd900d58.js');
require('../../_chunks/dep-e24d1659.js');
require('../../_chunks/dep-df011d17.js');

function useTableData(props) {
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var monthLocal = t(local.months);
  var quarterLocal = t(local.quarters);
  var start = props.start,
    end = props.end,
    hoverStart = props.hoverStart,
    hoverEnd = props.hoverEnd,
    year = props.year,
    month = props.month,
    mode = props.mode,
    firstDayOfWeek = props.firstDayOfWeek,
    disableDate = props.disableDate,
    minDate = props.minDate,
    maxDate = props.maxDate,
    isRange = props.isRange,
    value = props.value,
    multiple = props.multiple;
  var data = [];
  var options = {
    minDate: minDate,
    maxDate: maxDate,
    disableDate: disableDate,
    firstDayOfWeek: firstDayOfWeek,
    monthLocal: monthLocal,
    quarterLocal: quarterLocal,
    showWeekOfYear: mode === "week",
    dayjsLocale: local.dayjsLocale,
    cancelRangeSelectLimit: props.cancelRangeSelectLimit
  };
  if (mode === "date") {
    data = utils.getWeeks({
      year: year,
      month: month
    }, options);
  } else if (mode === "week") {
    data = utils.getWeeks({
      year: year,
      month: month
    }, options);
  } else if (mode === "quarter") {
    data = utils.getQuarters(year, options);
  } else if (mode === "month") {
    data = utils.getMonths(year, options);
  } else if (mode === "year") {
    data = utils.getYears(year, options);
  }
  return utils.flagActive(data, {
    start: start,
    end: end,
    hoverStart: hoverStart,
    hoverEnd: hoverEnd,
    type: mode,
    isRange: isRange,
    value: value,
    multiple: multiple
  });
}

exports["default"] = useTableData;
//# sourceMappingURL=useTableData.js.map
