/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var React = require('react');
var hooks_useConfig = require('../hooks/useConfig.js');
var descriptions_DescriptionsContext = require('./DescriptionsContext.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
require('../_chunks/dep-228d2001.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-fe81c65a.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var Row = function Row(props) {
  var row = props.row;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("descriptions"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var descriptionsContext = React.useContext(descriptions_DescriptionsContext.DescriptionsContext);
  var COMPONENT_NAME = "".concat(classPrefix, "-descriptions");
  var label = function label(node) {
    var layout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "horizontal";
    var rowKey = arguments.length > 2 ? arguments[2] : undefined;
    var span = node.span;
    var labelSpan = layout === "horizontal" ? 1 : span;
    return /* @__PURE__ */React__default["default"].createElement("td", {
      key: rowKey,
      colSpan: labelSpan,
      className: "".concat(COMPONENT_NAME, "__label"),
      style: descriptionsContext.labelStyle
    }, node.label, descriptionsContext.colon && t(locale.colonText));
  };
  var content = function content(node) {
    var layout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "horizontal";
    var rowKey = arguments.length > 2 ? arguments[2] : undefined;
    var span = node.span;
    var contentSpan = span > 1 && layout === "horizontal" ? span * 2 - 1 : span;
    return /* @__PURE__ */React__default["default"].createElement("td", {
      key: rowKey,
      colSpan: contentSpan,
      className: "".concat(COMPONENT_NAME, "__content"),
      style: descriptionsContext.contentStyle
    }, node.content);
  };
  var hh = function hh() {
    return /* @__PURE__ */React__default["default"].createElement("tr", null, row.map(function (node, i) {
      return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, {
        key: i
      }, label(node), content(node));
    }));
  };
  var hv = function hv() {
    return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */React__default["default"].createElement("tr", null, row.map(function (node, i) {
      return label(node, "vertical", "top_".concat(i));
    })), /* @__PURE__ */React__default["default"].createElement("tr", null, row.map(function (node, i) {
      return content(node, "vertical", "bottom_".concat(i));
    })));
  };
  var vh = function vh() {
    return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, row.map(function (node, i) {
      return /* @__PURE__ */React__default["default"].createElement("tr", {
        key: i
      }, label(node), content(node));
    }));
  };
  var vv = function vv() {
    return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, row.map(function (node, i) {
      return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, {
        key: i
      }, /* @__PURE__ */React__default["default"].createElement("tr", null, label(node)), /* @__PURE__ */React__default["default"].createElement("tr", null, content(node)));
    }));
  };
  if (descriptionsContext.layout === "horizontal") {
    if (descriptionsContext.itemLayout === "horizontal") {
      return hh();
    }
    return hv();
  }
  if (descriptionsContext.itemLayout === "horizontal") {
    return vh();
  }
  return vv();
};
Row.displayName = "DescriptionsRow";

exports["default"] = Row;
//# sourceMappingURL=Row.js.map
