/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var log = require('../_chunks/dep-53ae9438.js');
var _util_reactRender = require('../_util/react-render.js');
var drawer_Drawer = require('./Drawer.js');
var _util_style = require('../_chunks/dep-704d9321.js');
var configProvider_ConfigProvider = require('../config-provider/ConfigProvider.js');
require('../config-provider/ConfigContext.js');
var common_PluginContainer = require('../common/PluginContainer.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-1c5aedf3.js');
require('react-dom');
require('../_chunks/dep-2a791a26.js');
require('../_chunks/dep-3949d9f0.js');
require('../_chunks/dep-228d2001.js');
require('classnames');
require('react-transition-group');
require('tdesign-icons-react');
require('../locale/LocalReceiver.js');
require('../button/index.js');
require('../button/Button.js');
require('../hooks/useConfig.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-91f34d3d.js');
require('../hooks/useAnimation.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../common/Portal.js');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-dd0b0216.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../loading/plugin.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../button/defaultProps.js');
require('../_util/parseTNode.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('./hooks/useDrag.js');
require('./hooks/useLockStyle.js');
require('../_chunks/dep-e6a4e0ff.js');
require('../_util/scroll.js');
require('raf');
require('../_util/easing.js');
require('../hooks/useAttach.js');
require('../hooks/useSetState.js');
require('../_chunks/dep-2360fa32.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createDrawer = function createDrawer(props) {
  var drawerRef = /*#__PURE__*/React__default["default"].createRef();
  var _props$visible = props.visible,
    visible = _props$visible === void 0 ? false : _props$visible;
  var fragment = document.createDocumentFragment();
  var dGlobalConfig = configProvider_ConfigProvider["default"].getGlobalConfig();
  _util_reactRender.render(/* @__PURE__ */React__default["default"].createElement(common_PluginContainer["default"], {
    globalConfig: dGlobalConfig
  }, /* @__PURE__ */React__default["default"].createElement(drawer_Drawer["default"], _objectSpread(_objectSpread({}, props), {}, {
    visible: visible,
    ref: drawerRef,
    isPlugin: true
  }))), fragment);
  var container = _util_style.getAttach(props.attach);
  if (container) {
    requestAnimationFrame(function () {
      var _drawerRef$current;
      (_drawerRef$current = drawerRef.current) === null || _drawerRef$current === void 0 || _drawerRef$current.show();
    });
    container.appendChild(fragment);
  } else {
    log.log.error("Drawer", "attach is not exist");
  }
  var drawerNode = {
    show: function show() {
      requestAnimationFrame(function () {
        var _drawerRef$current2;
        (_drawerRef$current2 = drawerRef.current) === null || _drawerRef$current2 === void 0 || _drawerRef$current2.show();
      });
    },
    hide: function hide() {
      requestAnimationFrame(function () {
        var _drawerRef$current3;
        (_drawerRef$current3 = drawerRef.current) === null || _drawerRef$current3 === void 0 || _drawerRef$current3.destroy();
      });
    },
    update: function update(updateOptions) {
      requestAnimationFrame(function () {
        var _drawerRef$current4;
        (_drawerRef$current4 = drawerRef.current) === null || _drawerRef$current4 === void 0 || _drawerRef$current4.update(updateOptions);
      });
    },
    destroy: function destroy() {
      requestAnimationFrame(function () {
        var _drawerRef$current5;
        (_drawerRef$current5 = drawerRef.current) === null || _drawerRef$current5 === void 0 || _drawerRef$current5.destroy();
      });
    }
  };
  return drawerNode;
};
var DrawerPlugin = createDrawer;

exports.DrawerPlugin = DrawerPlugin;
//# sourceMappingURL=plugin.js.map
