/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-fe81c65a.js');
var React = require('react');
var dropdown_DropdownMenu = require('../DropdownMenu.js');
var dropdown_DropdownItem = require('../DropdownItem.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-3949d9f0.js');
require('../../_chunks/dep-228d2001.js');
require('classnames');
require('tdesign-icons-react');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../../divider/index.js');
require('../../divider/Divider.js');
require('../../_chunks/dep-2a791a26.js');
require('../../divider/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../hooks/useGlobalIcon.js');
require('../../_chunks/dep-6539e3d4.js');
require('../../_chunks/dep-0c1e22ea.js');
require('../../_chunks/dep-d5922382.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../hooks/useDomRefCallback.js');
require('../../hooks/useRipple.js');
require('../../_chunks/dep-91f34d3d.js');
require('../../hooks/useAnimation.js');
require('../../_chunks/dep-704d9321.js');
require('../../_chunks/dep-54722473.js');
require('../defaultProps.js');
require('../../_util/helper.js');
require('../../_chunks/dep-93919e5b.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');
require('../../_chunks/dep-d4f8f0c4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _getOptionsFromChildren = function getOptionsFromChildren(children) {
  if (!children) return [];
  if (children.type === dropdown_DropdownMenu["default"]) {
    var groupChildren = children.props.children;
    if (Array.isArray(groupChildren)) {
      return _getOptionsFromChildren(groupChildren);
    }
  }
  return React__default["default"].Children.toArray(children).map(function (item) {
    var _item$props, _item$props2;
    var groupChildren = (_item$props = item.props) === null || _item$props === void 0 ? void 0 : _item$props.children;
    var contextRes = (_item$props2 = item.props) === null || _item$props2 === void 0 ? void 0 : _item$props2.content;
    if (Array.isArray(groupChildren)) {
      var _groupChildren$filter, _groupChildren$filter2;
      var contentCtx = groupChildren === null || groupChildren === void 0 || (_groupChildren$filter = groupChildren.filter) === null || _groupChildren$filter === void 0 ? void 0 : _groupChildren$filter.call(groupChildren, function (v) {
        return ![dropdown_DropdownItem["default"], dropdown_DropdownMenu["default"]].includes(v.type);
      });
      var childrenCtx = groupChildren === null || groupChildren === void 0 || (_groupChildren$filter2 = groupChildren.filter) === null || _groupChildren$filter2 === void 0 ? void 0 : _groupChildren$filter2.call(groupChildren, function (v) {
        return [dropdown_DropdownItem["default"], dropdown_DropdownMenu["default"]].includes(v.type);
      });
      return _objectSpread(_objectSpread({}, item.props), {}, {
        content: contentCtx || groupChildren,
        children: childrenCtx.length > 0 ? _getOptionsFromChildren(groupChildren[1]) : null
      });
    }
    return _objectSpread(_objectSpread({}, item.props), {}, {
      content: groupChildren || contextRes,
      children: null
    });
  }).filter(function (v) {
    return !!v.content;
  });
};
function useDropdownOptions(children, options) {
  var dropdownOptions = React.useMemo(function () {
    if (options && options.length > 0) return options;
    var dropdownMenuChild;
    React__default["default"].Children.forEach(children, function (child) {
      if (! /*#__PURE__*/React__default["default"].isValidElement(child)) return;
      if (child.type === dropdown_DropdownMenu["default"] && child.props.children) {
        dropdownMenuChild = child.props.children;
      }
    });
    return _getOptionsFromChildren(dropdownMenuChild);
  }, [options, children]);
  return dropdownOptions;
}

exports["default"] = useDropdownOptions;
exports.getOptionsFromChildren = _getOptionsFromChildren;
//# sourceMappingURL=useDropdownOptions.js.map
