/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var empty_defaultProps = require('./defaultProps.js');
var image_index = require('../image/index.js');
var empty_assets_MaintenanceSvg = require('./assets/MaintenanceSvg.js');
var empty_assets_NetworkErrorSvg = require('./assets/NetworkErrorSvg.js');
var empty_assets_EmptySvg = require('./assets/EmptySvg.js');
var empty_assets_FailSvg = require('./assets/FailSvg.js');
var empty_assets_SuccessSvg = require('./assets/SuccessSvg.js');
var isObject = require('../_chunks/dep-3561ed02.js');
var isString = require('../_chunks/dep-54722473.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-bbe52a2d.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../image/Image.js');
require('../_chunks/dep-2a791a26.js');
require('tdesign-icons-react');
require('../_chunks/dep-03e4a661.js');
require('../image/defaultProps.js');
require('../space/index.js');
require('../space/Space.js');
require('react-is');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-dd0b0216.js');
require('../space/defaultProps.js');
require('../hooks/useGlobalIcon.js');
require('../hooks/useImagePreviewUrl.js');
require('../_chunks/dep-53ae9438.js');
require('../_chunks/dep-451b562c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function getImageIns(data) {
  var result = data;
  if (/*#__PURE__*/React.isValidElement(data)) {
    result = data;
  } else if (isObject.isObject(data)) {
    result = /* @__PURE__ */React__default["default"].createElement(image_index.Image, _objectSpread({}, data));
  } else if (isString.isString(data)) {
    result = /* @__PURE__ */React__default["default"].createElement(image_index.Image, {
      src: data
    });
  }
  return data ? result : null;
}
var Empty = function Empty(props) {
  var _defaultMaps$type, _typeImageProps$image, _typeImageProps$title;
  var _useDefaultProps = hooks_useDefaultProps["default"](props, empty_defaultProps.emptyDefaultProps),
    propsImage = _useDefaultProps.image,
    imageStyle = _useDefaultProps.imageStyle,
    propsDescription = _useDefaultProps.description,
    propsTitle = _useDefaultProps.title,
    type = _useDefaultProps.type,
    action = _useDefaultProps.action,
    style = _useDefaultProps.style,
    className = _useDefaultProps.className,
    _useDefaultProps$size = _useDefaultProps.size,
    size = _useDefaultProps$size === void 0 ? "medium" : _useDefaultProps$size;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix,
    empty = _useConfig.empty;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("empty"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var defaultMaps = {
    maintenance: {
      image: empty.image.maintenance || /* @__PURE__ */React__default["default"].createElement(empty_assets_MaintenanceSvg["default"], null),
      title: empty.titleText.maintenance || t(local.titleText.maintenance)
    },
    success: {
      image: empty.image.success || /* @__PURE__ */React__default["default"].createElement(empty_assets_SuccessSvg["default"], null),
      title: empty.titleText.success || t(local.titleText.success)
    },
    fail: {
      image: empty.image.fail || /* @__PURE__ */React__default["default"].createElement(empty_assets_FailSvg["default"], null),
      title: empty.titleText.fail || t(local.titleText.fail)
    },
    "network-error": {
      image: empty.image.networkError || /* @__PURE__ */React__default["default"].createElement(empty_assets_NetworkErrorSvg["default"], null),
      title: empty.titleText.networkError || t(local.titleText.networkError)
    },
    empty: {
      image: empty.image.empty || /* @__PURE__ */React__default["default"].createElement(empty_assets_EmptySvg["default"], null),
      title: empty.titleText.empty || t(local.titleText.empty)
    }
  };
  var defaultSize = {
    small: "".concat(classPrefix, "-size-s"),
    medium: "".concat(classPrefix, "-size"),
    large: "".concat(classPrefix, "-size-l")
  };
  var prefix = "".concat(classPrefix, "-empty");
  var emptyClasses = classNames__default["default"](prefix, className, defaultSize[size]);
  var titleClasses = classNames__default["default"]("".concat(prefix, "__title"));
  var imageClasses = classNames__default["default"]("".concat(prefix, "__image"));
  var descriptionClasses = classNames__default["default"]("".concat(prefix, "__description"));
  var actionCls = classNames__default["default"]("".concat(prefix, "__action"));
  var typeImageProps = (_defaultMaps$type = defaultMaps[type]) !== null && _defaultMaps$type !== void 0 ? _defaultMaps$type : null;
  var _image$title$descript = {
      image: propsImage ? propsImage : (_typeImageProps$image = typeImageProps === null || typeImageProps === void 0 ? void 0 : typeImageProps.image) !== null && _typeImageProps$image !== void 0 ? _typeImageProps$image : null,
      title: propsTitle ? propsTitle : (_typeImageProps$title = typeImageProps === null || typeImageProps === void 0 ? void 0 : typeImageProps.title) !== null && _typeImageProps$title !== void 0 ? _typeImageProps$title : null,
      description: propsDescription
    },
    image = _image$title$descript.image,
    description = _image$title$descript.description,
    title = _image$title$descript.title;
  function renderTitle() {
    if (!title) {
      return null;
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: titleClasses
    }, title);
  }
  function renderDescription() {
    if (!description) {
      return null;
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: descriptionClasses
    }, description);
  }
  var imageContent = getImageIns(image);
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: emptyClasses,
    style: style
  }, imageContent ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: imageClasses,
    style: imageStyle
  }, imageContent) : null, renderTitle(), renderDescription(), action ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionCls
  }, action) : null);
};

exports["default"] = Empty;
//# sourceMappingURL=Empty.js.map
