/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var tree_Tree = require('../../tree/Tree.js');
var upload_upload = require('../../upload/upload.js');
var tag_CheckTag = require('../../tag/CheckTag.js');
var checkbox_CheckboxGroup = require('../../_chunks/dep-41e5267c.js');
var tagInput_TagInput = require('../../tag-input/TagInput.js');
var rangeInput_RangeInput = require('../../range-input/RangeInput.js');
var transfer_Transfer = require('../../transfer/Transfer.js');
var datePicker_DateRangePicker = require('../../date-picker/DateRangePicker.js');
var timePicker_TimeRangePicker = require('../../time-picker/TimeRangePicker.js');
var form_FormContext = require('../FormContext.js');
var isEmpty = require('../../_chunks/dep-064ecbe2.js');
var get = require('../../_chunks/dep-65b91e54.js');
var omit = require('../../_chunks/dep-013699bc.js');
require('../../_chunks/dep-a21132eb.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-fe81c65a.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-3949d9f0.js');
require('react-transition-group');
require('classnames');
require('../../_chunks/dep-53ae9438.js');
require('../../tree/TreeItem.js');
require('../../_chunks/dep-2a791a26.js');
require('tdesign-icons-react');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../_chunks/dep-704d9321.js');
require('../../_chunks/dep-54722473.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-53bbe417.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-91f34d3d.js');
require('../../_chunks/dep-b066e7ac.js');
require('../../_chunks/dep-dd0b0216.js');
require('../../hooks/useDomRefCallback.js');
require('../../loading/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-1c5aedf3.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-f0e94cb0.js');
require('../../_chunks/dep-cd4fa758.js');
require('../../_chunks/dep-cf814f66.js');
require('../../_chunks/dep-7dbe9cf7.js');
require('../../_chunks/dep-bd900d58.js');
require('../../_chunks/dep-e24d1659.js');
require('../../_chunks/dep-df011d17.js');
require('../../hooks/useRipple.js');
require('../../hooks/useAnimation.js');
require('../../hooks/useGlobalIcon.js');
require('../../checkbox/index.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../common/Check.js');
require('../../_util/helper.js');
require('../../_chunks/dep-93919e5b.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_chunks/dep-14fc6700.js');
require('../../checkbox/defaultProps.js');
require('../../tree/hooks/useTreeConfig.js');
require('../../locale/LocalReceiver.js');
require('../../tree/hooks/useDraggable.js');
require('../../tree/hooks/TreeDraggableContext.js');
require('../../_util/createHookContext.js');
require('../../hooks/usePersistFn.js');
require('../../_chunks/dep-6539e3d4.js');
require('../../_chunks/dep-0c1e22ea.js');
require('../../_chunks/dep-d5922382.js');
require('../../_util/composeRefs.js');
require('../../tree/hooks/useControllable.js');
require('../../tree/hooks/useStore.js');
require('../../_chunks/dep-354a0f13.js');
require('../../_chunks/dep-3dc69e9b.js');
require('mitt');
require('../../_chunks/dep-bb95b18b.js');
require('../../_chunks/dep-2a9b9709.js');
require('../../_chunks/dep-556420c0.js');
require('../../_chunks/dep-b89fb5c8.js');
require('../../_chunks/dep-e9e51520.js');
require('../../_chunks/dep-3ae87727.js');
require('../../_chunks/dep-93a6e7a7.js');
require('../../_chunks/dep-2360fa32.js');
require('../../_chunks/dep-805fcdb5.js');
require('../../_chunks/dep-5669eec6.js');
require('../../_chunks/dep-3e9ca68a.js');
require('../../_chunks/dep-b275e705.js');
require('../../_chunks/dep-0a55a910.js');
require('../../_chunks/dep-9a247121.js');
require('../../hooks/useUpdateLayoutEffect.js');
require('../../hooks/useIsFirstRender.js');
require('../../hooks/usePrevious.js');
require('../../_chunks/dep-84fbcec5.js');
require('../../_util/parseTNode.js');
require('../../tree/hooks/useTreeVirtualScroll.js');
require('../../hooks/useVirtualScroll.js');
require('../../hooks/useResizeObserver.js');
require('../../hooks/useLatest.js');
require('../../hooks/useEventCallback.js');
require('../../upload/themes/NormalFile.js');
require('../../_chunks/dep-451b562c.js');
require('../../link/index.js');
require('../../link/Link.js');
require('../../link/defaultProps.js');
require('../../upload/themes/DraggerFile.js');
require('../../hooks/useCommonClassName.js');
require('../../upload/hooks/useDrag.js');
require('../../image-viewer/index.js');
require('../../image-viewer/ImageViewer.js');
require('../../_chunks/dep-ed534a43.js');
require('../../_chunks/dep-abd391c7.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../tooltip/index.js');
require('../../tooltip/Tooltip.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('../../popup/hooks/useTrigger.js');
require('react-is');
require('../../_util/ref.js');
require('../../_util/isFragment.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../hooks/useMutationObserver.js');
require('../../_chunks/dep-f31a7521.js');
require('../../_chunks/dep-12bca1df.js');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../hooks/useAttach.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../popup/PopupPlugin.js');
require('../../tooltip/defaultProps.js');
require('../../tooltip/TooltipLite.js');
require('../../hooks/useSwitch.js');
require('../../image-viewer/utils.js');
require('../../dialog/index.js');
require('../../dialog/Dialog.js');
require('../../hooks/useSetState.js');
require('../../dialog/defaultProps.js');
require('../../dialog/DialogCard.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../button/defaultProps.js');
require('../../dialog/hooks/useDialogEsc.js');
require('../../dialog/hooks/useLockStyle.js');
require('../../_chunks/dep-e6a4e0ff.js');
require('../../dialog/hooks/useDialogPosition.js');
require('../../dialog/hooks/useDialogDrag.js');
require('../../dialog/utils.js');
require('../../dialog/plugin.js');
require('../../image-viewer/hooks/useMirror.js');
require('../../image-viewer/hooks/usePosition.js');
require('../../image-viewer/hooks/useIndex.js');
require('../../image-viewer/hooks/useRotate.js');
require('../../image-viewer/hooks/useScale.js');
require('../../image-viewer/hooks/useIconMap.js');
require('../../image/index.js');
require('../../image/Image.js');
require('../../_chunks/dep-03e4a661.js');
require('../../image/defaultProps.js');
require('../../space/index.js');
require('../../space/Space.js');
require('../../space/defaultProps.js');
require('../../image-viewer/defaultProps.js');
require('../../image-viewer/hooks/useImageScale.js');
require('../../image-viewer/hooks/useList.js');
require('../../image-viewer/hooks/useViewerScale.js');
require('../../upload/themes/ImageCard.js');
require('../../upload/themes/MultipleFlowList.js');
require('../../upload/hooks/useUpload.js');
require('../../_chunks/dep-19ebc2c7.js');
require('../../upload/defaultProps.js');
require('../../upload/themes/CustomFile.js');
require('../../_chunks/dep-ccc9685f.js');
require('../../tag/defaultProps.js');
require('../../tag/Tag.js');
require('tinycolor2');
require('../../hooks/useDragSorter.js');
require('../../input/index.js');
require('../../input/Input.js');
require('../../input/InputGroup.js');
require('../../input/defaultProps.js');
require('../../input/useLengthLimit.js');
require('../../tag-input/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag/index.js');
require('../../tag/CheckTagGroup.js');
require('../../tag-input/useHover.js');
require('../../tag-input/defaultProps.js');
require('../../range-input/defaultProps.js');
require('../../transfer/TransferList.js');
require('../../transfer/utils.js');
require('../../pagination/index.js');
require('../../pagination/Pagination.js');
require('../../select/index.js');
require('../../select/base/Select.js');
require('../../select/util/helper.js');
require('../../select/base/OptionGroup.js');
require('../../select/defaultProps.js');
require('../../select/base/Option.js');
require('../../common/FakeArrow.js');
require('../../select-input/index.js');
require('../../select-input/SelectInput.js');
require('../../select-input/useSingle.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../select-input/defaultProps.js');
require('../../select/base/PopupContent.js');
require('../../select/hooks/usePanelVirtualScroll.js');
require('../../select/hooks/useOptions.js');
require('../../input-number/index.js');
require('../../input-number/InputNumber.js');
require('../../input-number/useInputNumber.js');
require('../../input-number/defaultProps.js');
require('../../input-adornment/InputAdornment.js');
require('../../pagination/hooks/useBoundaryJumper.js');
require('../../pagination/hooks/usePrevNextJumper.js');
require('../../pagination/hooks/usePageNumber.js');
require('../../pagination/hooks/useTotal.js');
require('../../pagination/validators.js');
require('../../pagination/defaultProps.js');
require('../../pagination/PaginationMini.js');
require('../../transfer/defaultProps.js');
require('../../_chunks/dep-c2a15b32.js');
require('../../_chunks/dep-2a5b1f0c.js');
require('../../_chunks/dep-4347efab.js');
require('../../range-input/index.js');
require('../../range-input/RangeInputPopup.js');
require('../../date-picker/panel/RangePanel.js');
require('../../date-picker/panel/PanelContent.js');
require('../../date-picker/base/Header.js');
require('../../date-picker/base/Table.js');
require('../../date-picker/base/Cell.js');
require('../../time-picker/index.js');
require('../../time-picker/TimePicker.js');
require('../../_chunks/dep-7dce15d8.js');
require('../../time-picker/hooks/useTimePickerTextConfig.js');
require('../../hooks/useDebounce.js');
require('../../hooks/usePropsRef.js');
require('../../time-picker/panel/TimePickerPanel.js');
require('../../time-picker/defaultProps.js');
require('../../date-picker/panel/ExtraContent.js');
require('../../date-picker/base/Footer.js');
require('../../date-picker/hooks/useTableData.js');
require('../../date-picker/hooks/useDisableDate.js');
require('../../date-picker/utils.js');
require('../../date-picker/hooks/useRange.js');
require('../../date-picker/hooks/useRangeValue.js');
require('../../date-picker/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/**
 * Removes the property at `path` of `object`.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to unset.
 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 7 } }] };
 * _.unset(object, 'a[0].b.c');
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 *
 * _.unset(object, ['a', '0', 'b', 'c']);
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 */
function unset(object, path) {
  return object == null ? true : omit.baseUnset(object, path);
}

var ctrlKeyMap = /* @__PURE__ */new Map();
ctrlKeyMap.set(checkbox_CheckboxGroup.Checkbox, "checked");
ctrlKeyMap.set(tag_CheckTag["default"], "checked");
ctrlKeyMap.set(upload_upload["default"], "files");
var initialDataMap = /* @__PURE__ */new Map();
[tree_Tree["default"], upload_upload["default"], transfer_Transfer["default"], tagInput_TagInput["default"], rangeInput_RangeInput["default"], checkbox_CheckboxGroup.CheckboxGroup, datePicker_DateRangePicker["default"], timePicker_TimeRangePicker["default"]].forEach(function (component) {
  initialDataMap.set(component, []);
});
[checkbox_CheckboxGroup.Checkbox].forEach(function (component) {
  initialDataMap.set(component, false);
});
function useFormItemInitialData(name) {
  var hadReadFloatingFormData = false;
  var _useFormContext = form_FormContext.useFormContext(),
    floatingFormDataRef = _useFormContext.floatingFormDataRef,
    formContextInitialData = _useFormContext.initialData;
  var _useFormListContext = form_FormContext.useFormListContext(),
    formListName = _useFormListContext.name,
    formListInitialData = _useFormListContext.initialData;
  React.useEffect(function () {
    if (hadReadFloatingFormData) {
      var nameList = formListName ? [formListName, name].flat() : name;
      unset(floatingFormDataRef.current, nameList);
    }
  }, [hadReadFloatingFormData, floatingFormDataRef, formListName, name]);
  function getDefaultInitialData(_ref) {
    var children = _ref.children,
      initialData = _ref.initialData;
    if (name && floatingFormDataRef !== null && floatingFormDataRef !== void 0 && floatingFormDataRef.current && !isEmpty.isEmpty(floatingFormDataRef.current)) {
      var nameList = formListName ? [formListName, name].flat() : name;
      var defaultInitialData = get.get(floatingFormDataRef.current, nameList);
      if (typeof defaultInitialData !== "undefined") {
        hadReadFloatingFormData = true;
        return defaultInitialData;
      }
    }
    if (typeof initialData !== "undefined") {
      return initialData;
    }
    if (name && formListInitialData.length) {
      var _defaultInitialData = get.get(formListInitialData, name);
      if (typeof _defaultInitialData !== "undefined") return _defaultInitialData;
    }
    if (name && formContextInitialData) {
      var _defaultInitialData2 = get.get(formContextInitialData, name);
      if (typeof _defaultInitialData2 !== "undefined") return _defaultInitialData2;
    }
    if (typeof children !== "function") {
      var childList = React__default["default"].Children.toArray(children);
      var lastChild = childList[childList.length - 1];
      if (lastChild && /*#__PURE__*/React__default["default"].isValidElement(lastChild)) {
        var _lastChild$props;
        var isMultiple = lastChild === null || lastChild === void 0 || (_lastChild$props = lastChild.props) === null || _lastChild$props === void 0 ? void 0 : _lastChild$props.multiple;
        return isMultiple ? [] : initialDataMap.get(lastChild.type);
      }
    }
  }
  return {
    getDefaultInitialData: getDefaultInitialData
  };
}

exports.ctrlKeyMap = ctrlKeyMap;
exports["default"] = useFormItemInitialData;
exports.initialDataMap = initialDataMap;
//# sourceMappingURL=useFormItemInitialData.js.map
