/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var React = require('react');
var form_hooks_useForm = require('./useForm.js');
var _util_noop = require('../../_util/noop.js');
var get = require('../../_chunks/dep-65b91e54.js');
var isUndefined = require('../../_chunks/dep-2360fa32.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-a21132eb.js');
require('../../_chunks/dep-3dc69e9b.js');
require('../../_chunks/dep-fe81c65a.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-53ae9438.js');
require('../../_chunks/dep-556420c0.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-4b5c6368.js');

function useWatch(name, form) {
  var _useState = React.useState(),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var valueStr = React.useMemo(function () {
    return JSON.stringify(value);
  }, [value]);
  var valueStrRef = React.useRef(valueStr);
  var isValidForm = form && form._init;
  React.useEffect(function () {
    var _form$getInternalHook3, _form$getFieldsValue2;
    if (!isValidForm) return;
    var _form$getInternalHook = (_form$getInternalHook3 = form.getInternalHooks) === null || _form$getInternalHook3 === void 0 ? void 0 : _form$getInternalHook3.call(form, form_hooks_useForm.HOOK_MARK),
      _form$getInternalHook2 = _form$getInternalHook.registerWatch,
      registerWatch = _form$getInternalHook2 === void 0 ? _util_noop["default"] : _form$getInternalHook2;
    var cancelRegister = registerWatch(function () {
      var _form$getFieldsValue;
      var allFieldsValue2 = (_form$getFieldsValue = form.getFieldsValue) === null || _form$getFieldsValue === void 0 ? void 0 : _form$getFieldsValue.call(form, true);
      var newValue = get.get(allFieldsValue2, name);
      var nextValueStr = JSON.stringify(newValue);
      if (valueStrRef.current !== nextValueStr) {
        valueStrRef.current = nextValueStr;
        setValue(nextValueStr);
      }
    });
    var allFieldsValue = (_form$getFieldsValue2 = form.getFieldsValue) === null || _form$getFieldsValue2 === void 0 ? void 0 : _form$getFieldsValue2.call(form, true);
    var initialValue = get.get(allFieldsValue, name);
    setValue(JSON.stringify(initialValue));
    return cancelRegister;
  }, []);
  return isUndefined.isUndefined(value) ? value : JSON.parse(value);
}

exports["default"] = useWatch;
//# sourceMappingURL=useWatch.js.map
