/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _util_style = require('../../_chunks/dep-704d9321.js');
var _util_scroll = require('../../_util/scroll.js');
require('../../_chunks/dep-54722473.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-53bbe417.js');
require('raf');
require('../../_util/easing.js');

function getRelativePosition(elm) {
  var relativeElm = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document.body;
  var _getWindowScroll = _util_scroll.getWindowScroll(),
    scrollTop = _getWindowScroll.scrollTop,
    scrollLeft = _getWindowScroll.scrollLeft;
  var _elm$getBoundingClien = elm.getBoundingClientRect(),
    elmTop = _elm$getBoundingClien.top,
    elmLeft = _elm$getBoundingClien.left;
  var _relativeElm$getBound = relativeElm.getBoundingClientRect(),
    relElmTop = _relativeElm$getBound.top,
    relElmLeft = _relativeElm$getBound.left;
  var relativeElmPosition = _util_style.getCssVarsValue("position", relativeElm);
  if (relativeElm.tagName.toLowerCase() !== "body" && relativeElmPosition === "relative" || relativeElmPosition === "sticky") {
    return {
      top: elmTop - relElmTop,
      left: elmLeft - relElmLeft
    };
  }
  if (_util_style.isFixed(elm)) {
    return {
      top: elmTop,
      left: elmLeft
    };
  }
  return {
    top: elmTop + scrollTop,
    left: elmLeft + scrollLeft
  };
}

exports["default"] = getRelativePosition;
//# sourceMappingURL=getRelativePosition.js.map
