/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var hooks_usePersistFn = require('./usePersistFn.js');
var debounce = require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');
require('../_chunks/dep-53bbe417.js');

var useDebounce = function useDebounce(func, delay, options) {
  var callback = hooks_usePersistFn.usePersistFn(func);
  var debounced = React.useCallback(debounce.debounce(callback, delay, options), [callback, delay, options]);
  React.useEffect(function () {
    return debounced.cancel;
  }, [debounced]);
  return debounced;
};

exports["default"] = useDebounce;
//# sourceMappingURL=useDebounce.js.map
