/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var React = require('react');
var _util_style = require('../_chunks/dep-704d9321.js');
var debounce = require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');

function useWindowSize() {
  var _useState = React.useState(_util_style.getWindowSize),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    size = _useState2[0],
    setSize = _useState2[1];
  React.useEffect(function () {
    function handleResize() {
      setSize(_util_style.getWindowSize());
    }
    var debounceResize = debounce.debounce(handleResize, 400);
    window.addEventListener("resize", debounceResize);
    return function () {
      window.removeEventListener("resize", debounceResize);
      debounceResize.cancel();
    };
  }, []);
  return size;
}

exports["default"] = useWindowSize;
//# sourceMappingURL=useWindowSize.js.map
