/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var React = require('react');
var hooks_useControlled = require('../../hooks/useControlled.js');
require('../../_chunks/dep-228d2001.js');
require('../../_util/noop.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-53bbe417.js');

var useIndex = function useIndex(resProps, images) {
  var _useControlled = hooks_useControlled["default"](resProps, "index", resProps.onIndexChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    index = _useControlled2[0],
    setIndex = _useControlled2[1];
  var next = React.useCallback(function () {
    var newIndex = index + 1;
    if (newIndex >= images.length) return index;
    setIndex(newIndex, {
      trigger: "next"
    });
  }, [setIndex, index, images.length]);
  var prev = React.useCallback(function () {
    var newIndex = index - 1 > 0 ? index - 1 : 0;
    setIndex(newIndex, {
      trigger: "prev"
    });
  }, [index, setIndex]);
  return {
    index: index,
    next: next,
    prev: prev,
    setIndex: setIndex
  };
};

exports["default"] = useIndex;
//# sourceMappingURL=useIndex.js.map
