/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var classNames = require('classnames');
var React = require('react');
var tabs_index = require('../tabs/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var menu_hooks_useMenuContext = require('./hooks/useMenuContext.js');
var menu_MenuContext = require('./MenuContext.js');
var menu__util_checkSubMenuActive = require('./_util/checkSubMenuActive.js');
var isObject = require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-bbe52a2d.js');
require('../tabs/Tabs.js');
require('../_chunks/dep-3949d9f0.js');
require('../_chunks/dep-228d2001.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../tabs/TabNav.js');
require('tdesign-icons-react');
require('../_util/noop.js');
require('../tabs/useTabClass.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../tabs/TabNavItem.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-91f34d3d.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useGlobalIcon.js');
require('../tabs/TabBar.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLayoutEffect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-53ae9438.js');
require('../_chunks/dep-013699bc.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-556420c0.js');
require('../_chunks/dep-84fbcec5.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-3ae87727.js');
require('../_chunks/dep-93a6e7a7.js');
require('../tabs/TabPanel.js');
require('../tabs/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../_chunks/dep-a21132eb.js');
require('./_util/checkSubMenuChildExpanded.js');
require('./_util/type.js');
require('../_chunks/dep-42e4b4c6.js');
require('./_util/checkMenuType.js');
require('./_util/checkSubMenuChildrenActive.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var _excluded = ["children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TabPanel = tabs_index.Tabs.TabPanel;
var HeadMenu = function HeadMenu(props) {
  var children = props.children,
    className = props.className,
    _props$theme = props.theme,
    theme = _props$theme === void 0 ? "light" : _props$theme,
    style = props.style,
    logo = props.logo,
    operations = props.operations;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useMenuContext = menu_hooks_useMenuContext["default"](_objectSpread(_objectSpread({}, props), {}, {
      children: children,
      mode: "title"
    })),
    value = _useMenuContext.value;
  var childList = React.useMemo(function () {
    if (value.expandType === "popup") return null;
    var activeMenu = menu__util_checkSubMenuActive["default"](children, value.active);
    if (!activeMenu) return null;
    var child = activeMenu.props.children;
    if (Array.isArray(child)) return child;
    if (isObject.isObject(child)) return [child];
    return activeMenu.props.children;
  }, [children, value.expandType, value.active]);
  var currentChildListValues = (childList === null || childList === void 0 ? void 0 : childList.length) > 0 ? childList.map(function (item) {
    return item.props.value;
  }) : [];
  return /* @__PURE__ */React__default["default"].createElement(menu_MenuContext.MenuContext.Provider, {
    value: value
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]("".concat(classPrefix, "-head-menu"), "".concat(classPrefix, "-menu--").concat(theme), className),
    style: _objectSpread({}, style)
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-head-menu__inner")
  }, logo && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__logo")
  }, logo), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "".concat(classPrefix, "-menu")
  }, children), operations && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__operations")
  }, operations)), (childList === null || childList === void 0 ? void 0 : childList.length) > 0 && /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "".concat(classPrefix, "-head-menu__submenu ").concat(classPrefix, "-submenu")
  }, /* @__PURE__ */React__default["default"].createElement(tabs_index.Tabs, {
    value: currentChildListValues.includes(value.active) ? value.active : currentChildListValues[0],
    onChange: value.onChange
  }, childList.map(function (_ref) {
    var _ref$props = _ref.props,
      children2 = _ref$props.children,
      restProps = objectWithoutProperties._objectWithoutProperties(_ref$props, _excluded);
    return /* @__PURE__ */React__default["default"].createElement(TabPanel, _objectSpread(_objectSpread({
      key: props.value
    }, restProps), {}, {
      label: children2
    }));
  })))));
};

exports["default"] = HeadMenu;
//# sourceMappingURL=HeadMenu.js.map
