/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var menu_MenuContext = require('./MenuContext.js');
var menu__util_constant = require('./_util/constant.js');
var menu_hooks_useMenuContext = require('./hooks/useMenuContext.js');
var menu_defaultProps = require('./defaultProps.js');
var menu_HeadMenu = require('./HeadMenu.js');
var menu_SubMenu = require('./SubMenu.js');
var menu_MenuItem = require('./MenuItem.js');
var menu_MenuGroup = require('./MenuGroup.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-bbe52a2d.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('hoist-non-react-statics');
require('../_util/noop.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-3949d9f0.js');
require('./_util/checkSubMenuChildExpanded.js');
require('./_util/type.js');
require('../_chunks/dep-42e4b4c6.js');
require('../_chunks/dep-2a791a26.js');
require('../tabs/index.js');
require('../tabs/Tabs.js');
require('../tabs/TabNav.js');
require('tdesign-icons-react');
require('../tabs/useTabClass.js');
require('../tabs/TabNavItem.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-91f34d3d.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useGlobalIcon.js');
require('../tabs/TabBar.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLayoutEffect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-53ae9438.js');
require('../_chunks/dep-013699bc.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-556420c0.js');
require('../_chunks/dep-84fbcec5.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-3ae87727.js');
require('../_chunks/dep-93a6e7a7.js');
require('../tabs/TabPanel.js');
require('../tabs/defaultProps.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('./_util/checkSubMenuActive.js');
require('./_util/checkMenuType.js');
require('./_util/checkSubMenuChildrenActive.js');
require('react-transition-group');
require('./_util/getSubMenuChildStyle.js');
require('../common/FakeArrow.js');
require('./_util/cacularPaddingLeft.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('../hooks/useControlled.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../common/Portal.js');
require('react-dom');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../tooltip/index.js');
require('../tooltip/Tooltip.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-6539e3d4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Menu = _util_forwardRefWithStatics["default"](function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, menu_defaultProps.menuDefaultProps);
  var className = props.className,
    _props$width = props.width,
    width = _props$width === void 0 ? menu__util_constant.DEFAULT_MENU_WIDTH : _props$width,
    children = props.children,
    theme = props.theme,
    logo = props.logo,
    operations = props.operations,
    style = props.style;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useMenuContext = menu_hooks_useMenuContext["default"](_objectSpread(_objectSpread({}, props), {}, {
      children: children,
      mode: "accordion"
    })),
    value = _useMenuContext.value;
  var menuWidthArr = Array.isArray(width) ? width : [width, menu__util_constant.DEFAULT_MENU_WIDTH[1]];
  var collapsed = value.collapsed;
  return /* @__PURE__ */React__default["default"].createElement(menu_MenuContext.MenuContext.Provider, {
    value: value
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: classNames__default["default"]("".concat(classPrefix, "-default-menu"), className, defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-collapsed"), collapsed), "".concat(classPrefix, "-menu--dark"), theme === "dark")),
    style: _objectSpread({
      width: collapsed ? menuWidthArr[1] : menuWidthArr[0]
    }, style)
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-default-menu__inner")
  }, logo && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__logo")
  }, logo), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(classPrefix, "-menu"), "".concat(classPrefix, "-menu--scroll"))
  }, children), operations && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__operations")
  }, operations))));
}, {
  HeadMenu: menu_HeadMenu["default"],
  SubMenu: menu_SubMenu["default"],
  MenuItem: menu_MenuItem["default"],
  MenuGroup: menu_MenuGroup["default"]
});
Menu.displayName = "Menu";

exports["default"] = Menu;
//# sourceMappingURL=Menu.js.map
