/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-a21132eb.js');
var _typeof = require('../_chunks/dep-bbe52a2d.js');
var notification_NotificationList = require('../_chunks/dep-fb8ea5e0.js');
var notification_config = require('./config.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-fe81c65a.js');
require('react');
require('classnames');
require('tdesign-icons-react');
require('../_chunks/dep-3949d9f0.js');
require('../_util/react-render.js');
require('../_chunks/dep-1c5aedf3.js');
require('react-dom');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../_util/noop.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-53ae9438.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../common/PluginContainer.js');

var renderNotification = function renderNotification(theme, options) {
  if (_typeof._typeof(options) !== "object") return;
  var configs = notification_config.getConfig(options);
  var placement = configs.placement;
  var attach = function () {
    var containerId = "tdesign-notification-".concat(placement);
    var container = document.querySelector("#".concat(containerId));
    if (container && container instanceof HTMLElement) {
      return container;
    }
    var element = document.createElement("div");
    element.setAttribute("id", containerId);
    if (options.attach && typeof options.attach === "string") {
      var container2 = document.querySelector(options.attach);
      if (container2 instanceof HTMLElement) return container2.appendChild(element);
    }
    if (options.attach instanceof HTMLElement) return options.attach.appendChild(element);
    document.body.appendChild(element);
    return element;
  }();
  return notification_NotificationList.fetchListInstance(placement, attach, configs.zIndex).then(function (listInstance) {
    return listInstance.push(theme, configs);
  });
};
var NotificationPlugin = function NotificationPlugin(theme, props) {
  return renderNotification(theme, props);
};
NotificationPlugin.info = function (options) {
  return renderNotification("info", options);
};
NotificationPlugin.success = function (options) {
  return renderNotification("success", options);
};
NotificationPlugin.warning = function (options) {
  return renderNotification("warning", options);
};
NotificationPlugin.error = function (options) {
  return renderNotification("error", options);
};
NotificationPlugin.close = function (promise) {
  return promise.then(function (instance) {
    return instance.close();
  });
};
NotificationPlugin.closeAll = function () {
  return toConsumableArray._toConsumableArray(notification_NotificationList.listMap.values()).forEach(function (list) {
    return list.removeAll();
  });
};
NotificationPlugin.config = function (options) {
  return notification_config.setGlobalConfig(options);
};

exports.NotificationPlugin = NotificationPlugin;
//# sourceMappingURL=NotificationPlugin.js.map
