/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var React = require('react');
var classNames = require('classnames');
var _util_noop = require('../_util/noop.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var select_index = require('../select/index.js');
var inputNumber_index = require('../input-number/index.js');
var inputAdornment_InputAdornment = require('../input-adornment/InputAdornment.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var pagination_hooks_useBoundaryJumper = require('./hooks/useBoundaryJumper.js');
var pagination_hooks_usePrevNextJumper = require('./hooks/usePrevNextJumper.js');
var pagination_hooks_usePageNumber = require('./hooks/usePageNumber.js');
var pagination_hooks_useTotal = require('./hooks/useTotal.js');
var pagination_validators = require('./validators.js');
var pagination_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var omit = require('../_chunks/dep-013699bc.js');
var isNumber = require('../_chunks/dep-dd0b0216.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-228d2001.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7e859ab6.js');
require('../select/base/Select.js');
require('../_util/helper.js');
require('../_chunks/dep-93919e5b.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../select/util/helper.js');
require('../_chunks/dep-a21132eb.js');
require('../select/base/OptionGroup.js');
require('../select/defaultProps.js');
require('../select/base/Option.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-91f34d3d.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-65b91e54.js');
require('../_chunks/dep-556420c0.js');
require('../common/FakeArrow.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-b066e7ac.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-1c5aedf3.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../select-input/index.js');
require('../select-input/SelectInput.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../select-input/useSingle.js');
require('../input/index.js');
require('../input/Input.js');
require('tdesign-icons-react');
require('../hooks/useGlobalIcon.js');
require('../input/InputGroup.js');
require('../input/defaultProps.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-53ae9438.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-2a9b9709.js');
require('../_chunks/dep-b89fb5c8.js');
require('../_chunks/dep-e9e51520.js');
require('../_chunks/dep-3ae87727.js');
require('../_chunks/dep-93a6e7a7.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/TagInput.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../tag-input/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/Tag.js');
require('tinycolor2');
require('../tag/defaultProps.js');
require('../tag/CheckTag.js');
require('../_chunks/dep-ccc9685f.js');
require('../tag/CheckTagGroup.js');
require('../tag-input/useHover.js');
require('../tag-input/defaultProps.js');
require('../select-input/useOverlayInnerStyle.js');
require('../select-input/defaultProps.js');
require('../select/base/PopupContent.js');
require('../select/hooks/usePanelVirtualScroll.js');
require('../hooks/useVirtualScroll.js');
require('../hooks/useResizeObserver.js');
require('../select/hooks/useOptions.js');
require('../input-number/InputNumber.js');
require('../button/index.js');
require('../button/Button.js');
require('../button/defaultProps.js');
require('../input-number/useInputNumber.js');
require('../_chunks/dep-abd391c7.js');
require('../_chunks/dep-2360fa32.js');
require('../hooks/useCommonClassName.js');
require('../input-number/defaultProps.js');
require('../_chunks/dep-84fbcec5.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

/**
 * Checks if `value` is `NaN`.
 *
 * **Note:** This method is based on
 * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as
 * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for
 * `undefined` and other non-number values.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 * @example
 *
 * _.isNaN(NaN);
 * // => true
 *
 * _.isNaN(new Number(NaN));
 * // => true
 *
 * isNaN(undefined);
 * // => true
 *
 * _.isNaN(undefined);
 * // => false
 */
function isNaN(value) {
  // An `NaN` primitive is the only value that is not equal to itself.
  // Perform the `toStringTag` check first to avoid errors with some
  // ActiveX objects in IE.
  return isNumber.isNumber(value) && value != +value;
}

var _excluded = ["theme", "size", "total", "showPageSize", "showPageNumber", "showPreviousAndNextBtn", "showFirstAndLastPageBtn", "showJumper", "pageEllipsisMode", "disabled", "foldedMaxPageBtn", "maxPageBtn", "totalContent", "pageSizeOptions", "onChange", "onCurrentChange", "onPageSizeChange", "style", "className", "selectProps"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Option = select_index.Select.Option;
var Pagination = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, pagination_defaultProps.paginationDefaultProps);
  var theme = props.theme,
    size = props.size,
    total = props.total,
    showPageSize = props.showPageSize,
    showPageNumber = props.showPageNumber,
    showPreviousAndNextBtn = props.showPreviousAndNextBtn,
    showFirstAndLastPageBtn = props.showFirstAndLastPageBtn,
    showJumper = props.showJumper,
    pageEllipsisMode = props.pageEllipsisMode,
    disabled = props.disabled,
    foldedMaxPageBtn = props.foldedMaxPageBtn,
    maxPageBtn = props.maxPageBtn,
    totalContent = props.totalContent,
    pageSizeOptions = props.pageSizeOptions,
    _props$onChange = props.onChange,
    onChange = _props$onChange === void 0 ? _util_noop["default"] : _props$onChange,
    onCurrentChange = props.onCurrentChange,
    onPageSizeChange = props.onPageSizeChange,
    style = props.style,
    className = props.className,
    selectProps = props.selectProps,
    otherProps = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var restProps = omit.omit(otherProps, ["current", "pageSize", "defaultPageSize", "defaultCurrent"]);
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("pagination"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useControlled = hooks_useControlled["default"](props, "pageSize", onPageSizeChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    pageSize = _useControlled2[0],
    setPageSize = _useControlled2[1];
  var _useControlled3 = hooks_useControlled["default"](props, "current", onCurrentChange),
    _useControlled4 = slicedToArray._slicedToArray(_useControlled3, 2),
    current = _useControlled4[0],
    setCurrent = _useControlled4[1];
  var _useState = React.useState(current),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    jumpValue = _useState2[0],
    setJumpValue = _useState2[1];
  var min = 1;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix,
    paginationConfig = _useConfig.pagination;
  var name = "".concat(classPrefix, "-pagination");
  var pageCount = React.useMemo(function () {
    var calCount = Math.ceil(total / pageSize);
    return calCount > 0 ? calCount : 1;
  }, [pageSize, total]);
  var changeCurrent = function changeCurrent(_nextCurrent, _nextPageSize) {
    if (disabled || current === _nextCurrent) {
      return;
    }
    var nextCurrent = Math.trunc(_nextCurrent);
    if (isNaN(nextCurrent)) return;
    var nextPageSize = _nextPageSize;
    if (!nextPageSize && !pagination_validators.pageSizeValidator(nextPageSize)) {
      var _pageSizeOptions$;
      nextPageSize = pageSize !== null && pageSize !== void 0 ? pageSize : typeof pageSizeOptions[0] === "number" ? pageSizeOptions[0] : (_pageSizeOptions$ = pageSizeOptions[0]) === null || _pageSizeOptions$ === void 0 ? void 0 : _pageSizeOptions$.value;
    }
    if (nextCurrent < min) nextCurrent = min;
    if (nextCurrent > pageCount) nextCurrent = pageCount;
    setCurrent(nextCurrent, {
      current: nextCurrent,
      previous: current,
      pageSize: nextPageSize
    });
    onChange({
      current: nextCurrent,
      previous: current,
      pageSize: nextPageSize
    });
  };
  var changePageSize = function changePageSize(nextPageSize) {
    var nextCurrent = Math.min(current, Math.max(1, Math.ceil(total / nextPageSize)));
    var pageInfo = {
      current: nextCurrent,
      previous: current,
      pageSize: nextPageSize
    };
    setPageSize(nextPageSize, pageInfo);
    if (current !== nextCurrent) {
      changeCurrent(nextCurrent, nextPageSize);
    } else {
      onChange(pageInfo);
    }
  };
  var _useTotal = pagination_hooks_useTotal["default"]({
      totalContent: totalContent,
      pageSize: pageSize,
      current: current,
      total: total
    }),
    totalControl = _useTotal.totalControl;
  var _useBoundaryJumper = pagination_hooks_useBoundaryJumper["default"]({
      disabled: disabled,
      current: current,
      pageCount: pageCount,
      showFirstAndLastPageBtn: showFirstAndLastPageBtn,
      changeCurrent: changeCurrent
    }),
    firstPageJumper = _useBoundaryJumper.firstPageJumper,
    lastPageJumper = _useBoundaryJumper.lastPageJumper;
  var _usePrevNextJumper = pagination_hooks_usePrevNextJumper["default"]({
      disabled: disabled,
      current: current,
      pageCount: pageCount,
      showPreviousAndNextBtn: showPreviousAndNextBtn,
      changeCurrent: changeCurrent
    }),
    prevJumper = _usePrevNextJumper.prevJumper,
    nextJumper = _usePrevNextJumper.nextJumper;
  var _usePageNumber = pagination_hooks_usePageNumber["default"]({
      showPageNumber: showPageNumber,
      maxPageBtn: maxPageBtn,
      disabled: disabled,
      current: current,
      pageCount: pageCount,
      foldedMaxPageBtn: foldedMaxPageBtn,
      changeCurrent: changeCurrent,
      pageEllipsisMode: pageEllipsisMode
    }),
    pageNumberControl = _usePageNumber.pageNumberControl;
  React.useEffect(function () {
    setJumpValue(current);
  }, [current]);
  var pageSizeControl = showPageSize && pageSizeOptions.length ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(name, "__select")
  }, /* @__PURE__ */React__default["default"].createElement(select_index.Select, _objectSpread({
    autoWidth: true,
    size: size,
    value: pageSize,
    disabled: disabled,
    onChange: changePageSize
  }, selectProps), pageSizeOptions.map(function (item) {
    return typeof item === "number" ? /* @__PURE__ */React__default["default"].createElement(Option, {
      key: item,
      label: t(locale.itemsPerPage, {
        size: item
      }),
      value: item
    }) : /* @__PURE__ */React__default["default"].createElement(Option, {
      key: item.value,
      label: item.label,
      value: item.value
    });
  }))) : null;
  var DefaultJumper = /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(name, "__jump")
  }, t(locale.jumpTo), /* @__PURE__ */React__default["default"].createElement(inputAdornment_InputAdornment["default"], {
    append: "/ ".concat(pageCount, " ").concat(t(locale.page))
  }, /* @__PURE__ */React__default["default"].createElement(inputNumber_index.InputNumber, {
    className: "".concat(classPrefix, "-pagination__input"),
    min: min,
    size: size,
    theme: "normal",
    max: pageCount,
    disabled: disabled,
    value: jumpValue,
    onChange: function onChange(val) {
      return setJumpValue(val);
    },
    onBlur: function onBlur(val) {
      return changeCurrent(val);
    },
    onEnter: function onEnter(val) {
      return changeCurrent(val);
    },
    placeholder: ""
  })));
  var globalJumper = paginationConfig.jumper;
  var Jumper = globalJumper ? globalJumper({
    current: current,
    pageCount: pageCount,
    onChange: changeCurrent
  }) : DefaultJumper;
  return /* @__PURE__ */React__default["default"].createElement("div", _objectSpread({
    className: classNames__default["default"](name, className, defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-size-s"), size === "small"), "".concat(classPrefix, "-is-disabled"), disabled)),
    style: style,
    ref: ref
  }, restProps), totalControl, pageSizeControl, firstPageJumper, prevJumper, theme === "default" && pageNumberControl, theme === "simple" && Jumper, nextJumper, lastPageJumper, theme === "default" && showJumper && Jumper);
});
Pagination.displayName = "Pagination";

exports["default"] = Pagination;
//# sourceMappingURL=Pagination.js.map
