/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var common = require('../_chunks/dep-ccc9685f.js');
var _util_listener = require('../_util/listener.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-53bbe417.js');

function useKeyboard(radioGroupRef, setInnerValue) {
  var checkRadioInGroup = function checkRadioInGroup(e) {
    if (common.CHECKED_CODE_REG.test(e.key) || common.CHECKED_CODE_REG.test(e.code)) {
      var inputNode = e.target.querySelector("input");
      var data = (inputNode === null || inputNode === void 0 ? void 0 : inputNode.dataset) || {};
      if (inputNode.checked && data.allowUncheck) {
        setInnerValue(void 0, {
          e: e
        });
      } else {
        var value = !isNaN(Number(data.value)) ? Number(data.value) : data.value;
        value = typeof value === "string" && {
          "true": true,
          "false": false
        }[value] || value;
        value = typeof value === "string" && value[0] === "'" ? value.replace(/'/g, "") : value;
        setInnerValue(value, {
          e: e
        });
      }
    }
  };
  React.useEffect(function () {
    _util_listener.on(radioGroupRef.current, "keydown", checkRadioInGroup);
    return function () {
      _util_listener.off(radioGroupRef.current, "keydown", checkRadioInGroup);
    };
  }, []);
}

exports["default"] = useKeyboard;
//# sourceMappingURL=useKeyboard.js.map
