/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-a21132eb.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var tooltip_index = require('../tooltip/index.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var rate_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-bbe52a2d.js');
require('../tooltip/Tooltip.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useAnimation.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../_util/noop.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-6539e3d4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["icon"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var RateIcon = function RateIcon(_ref) {
  var icon = _ref.icon,
    props = objectWithoutProperties._objectWithoutProperties(_ref, _excluded);
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      StarFilledIcon: tdesignIconsReact.StarFilledIcon
    }),
    StarFilledIcon = _useGlobalIcon.StarFilledIcon;
  if (/*#__PURE__*/React__default["default"].isValidElement(icon)) {
    return /*#__PURE__*/React__default["default"].cloneElement(icon, props);
  }
  return /* @__PURE__ */React__default["default"].createElement(StarFilledIcon, _objectSpread({}, props));
};
var Rate = /*#__PURE__*/React__default["default"].forwardRef(function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, rate_defaultProps.rateDefaultProps);
  var allowHalf = props.allowHalf,
    color = props.color,
    count = props.count,
    disabled = props.disabled,
    gap = props.gap,
    showText = props.showText,
    size = props.size,
    icon = props.icon,
    className = props.className,
    style = props.style,
    onChange = props.onChange,
    texts = props.texts,
    clearable = props.clearable;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("rate"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var displayTexts = texts.length ? texts : t(locale.rateText);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useControlled = hooks_useControlled["default"](props, "value", onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    starValue = _useControlled2[0],
    setStarValue = _useControlled2[1];
  var _useState = React.useState(void 0),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    hoverValue = _useState2[0],
    setHoverValue = _useState2[1];
  var displayValue = hoverValue || starValue;
  var rootRef = React__default["default"].useRef(null);
  var activeColor = Array.isArray(color) ? color[0] : color;
  var defaultColor = Array.isArray(color) ? color[1] : "var(--td-bg-color-component)";
  var getStarValue = function getStarValue(event, index) {
    if (allowHalf) {
      var rootNode = rootRef.current;
      var _rootNode$getBounding = rootNode.getBoundingClientRect(),
        left = _rootNode$getBounding.left;
      var firstStar = rootNode.firstChild;
      var _firstStar$getBoundin = firstStar.getBoundingClientRect(),
        width = _firstStar$getBoundin.width;
      var clientX = event.clientX;
      var starMiddle = width * (index - 0.5) + gap * (index - 1);
      if (clientX - left >= starMiddle) {
        return index;
      }
      if (clientX - left < starMiddle) {
        return index - 0.5;
      }
    }
    return index;
  };
  var mouseEnterHandler = function mouseEnterHandler(event, index) {
    if (disabled) {
      return;
    }
    setHoverValue(getStarValue(event, index));
  };
  var mouseLeaveHandler = function mouseLeaveHandler() {
    if (disabled) {
      return;
    }
    setHoverValue(void 0);
  };
  var clickHandler = function clickHandler(event, index) {
    if (disabled) {
      return;
    }
    var value = getStarValue(event, index);
    if (clearable && value === starValue) {
      value = 0;
      setHoverValue(void 0);
    }
    setStarValue(value);
  };
  var getStarCls = function getStarCls(index) {
    if (allowHalf && index + 0.5 === displayValue) {
      return "".concat(classPrefix, "-rate__item--half");
    }
    if (index >= displayValue) {
      return "";
    }
    if (index < displayValue) {
      return "".concat(classPrefix, "-rate__item--full");
    }
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    style: style,
    className: classNames__default["default"]("".concat(classPrefix, "-rate"), className),
    onMouseLeave: mouseLeaveHandler
  }, /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "".concat(classPrefix, "-rate__list"),
    style: {
      gap: gap
    },
    ref: rootRef
  }, toConsumableArray._toConsumableArray(Array(count)).map(function (_, index) {
    return /* @__PURE__ */React__default["default"].createElement("li", {
      key: index,
      className: classNames__default["default"]("".concat(classPrefix, "-rate__item"), getStarCls(index)),
      onClick: function onClick(event) {
        return clickHandler(event, index + 1);
      },
      onMouseMove: function onMouseMove(event) {
        return mouseEnterHandler(event, index + 1);
      }
    }, showText ? /* @__PURE__ */React__default["default"].createElement(tooltip_index.TooltipLite, {
      key: index,
      content: displayTexts[displayValue - 1]
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-rate__star-top")
    }, /* @__PURE__ */React__default["default"].createElement(RateIcon, {
      size: size,
      color: activeColor,
      icon: icon
    })), /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-rate__star-bottom")
    }, /* @__PURE__ */React__default["default"].createElement(RateIcon, {
      size: size,
      color: defaultColor,
      icon: icon
    }))) : /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-rate__star-top")
    }, /* @__PURE__ */React__default["default"].createElement(RateIcon, {
      size: size,
      color: activeColor,
      icon: icon
    })), /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-rate__star-bottom")
    }, /* @__PURE__ */React__default["default"].createElement(RateIcon, {
      size: size,
      color: defaultColor,
      icon: icon
    }))));
  })), showText && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-rate__text")
  }, displayTexts[displayValue - 1]));
});
Rate.displayName = "Rate";

exports["default"] = Rate;
//# sourceMappingURL=Rate.js.map
