/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var stickyTool_StickyItem = require('./StickyItem.js');
var stickyTool_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-bbe52a2d.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('hoist-non-react-statics');
require('../popup/index.js');
require('../popup/Popup.js');
require('../_chunks/dep-3949d9f0.js');
require('../_chunks/dep-228d2001.js');
require('react-transition-group');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/useAnimation.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-a21132eb.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var StickyTool = _util_forwardRefWithStatics["default"](function (props, ref) {
  var _useDefaultProps = hooks_useDefaultProps["default"](props, stickyTool_defaultProps.stickyToolDefaultProps),
    style = _useDefaultProps.style,
    className = _useDefaultProps.className,
    children = _useDefaultProps.children,
    width = _useDefaultProps.width,
    type = _useDefaultProps.type,
    shape = _useDefaultProps.shape,
    placement = _useDefaultProps.placement,
    offset = _useDefaultProps.offset,
    popupProps = _useDefaultProps.popupProps,
    list = _useDefaultProps.list,
    onClick = _useDefaultProps.onClick,
    onHover = _useDefaultProps.onHover;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var styles = React.useMemo(function () {
    var position = offset ? [80, 24] : ["80px", "24px"];
    offset === null || offset === void 0 || offset.forEach(function (item, index) {
      position[index] = isNaN(Number(item)) ? "calc( ".concat(position[index], "px + ").concat(item, ")") : "".concat(position[index] + item, "px");
    });
    var styles2 = _objectSpread({}, style);
    placement.split("-").forEach(function (item, index) {
      if (item !== "center") {
        styles2[item] = position[index];
      } else {
        styles2.top = "50%";
        styles2.transform = "translate(0, -50%)";
      }
    });
    if (width) {
      styles2.width = typeof width === "number" ? "".concat(width, "px") : width;
    }
    return styles2;
  }, [offset, placement, width, style]);
  var handleClick = React.useCallback(function (context) {
    onClick === null || onClick === void 0 || onClick(context);
  }, [onClick]);
  var handleHover = React.useCallback(function (context) {
    onHover === null || onHover === void 0 || onHover(context);
  }, [onHover]);
  var stickyItemList = React.useMemo(function () {
    if (list !== null && list !== void 0 && list.length) {
      return list.map(function (item, index) {
        var itemProps = _objectSpread(_objectSpread({}, item), {}, {
          type: type,
          shape: shape,
          placement: placement,
          basePopupProps: popupProps,
          baseWidth: styles.width,
          onClick: handleClick,
          onHover: handleHover
        });
        return /* @__PURE__ */React__default["default"].createElement(stickyTool_StickyItem["default"], _objectSpread({
          key: index
        }, itemProps));
      });
    }
    var childrenList = React__default["default"].Children.toArray(children);
    return childrenList.map(function (child) {
      var itemProps = _objectSpread(_objectSpread({}, child.props), {}, {
        type: type,
        shape: shape,
        placement: placement,
        basePopupProps: popupProps,
        baseWidth: styles.width,
        onClick: handleClick,
        onHover: handleHover
      });
      return /*#__PURE__*/React__default["default"].cloneElement(child, _objectSpread({}, itemProps));
    });
  }, [list, children, type, shape, placement, popupProps, styles, handleClick, handleHover]);
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    style: styles,
    className: classNames__default["default"]("".concat(classPrefix, "-sticky-tool"), "".concat(classPrefix, "-sticky-tool--").concat(shape), className)
  }, stickyItemList);
}, {
  StickyItem: stickyTool_StickyItem["default"]
});
StickyTool.displayName = "StickyTool";

exports["default"] = StickyTool;
//# sourceMappingURL=StickyTool.js.map
