/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var React = require('react');
var classNames = require('classnames');
var log = require('../_chunks/dep-53ae9438.js');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var switch_defaultProps = require('./defaultProps.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-228d2001.js');
require('../loading/Loading.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-53bbe417.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-91f34d3d.js');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-dd0b0216.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-1c5aedf3.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["className", "value", "defaultValue", "disabled", "loading", "size", "label", "customValue", "onChange", "beforeChange"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Switch = /*#__PURE__*/React__default["default"].forwardRef(function (originalProps, ref) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var props = hooks_useDefaultProps["default"](originalProps, switch_defaultProps.switchDefaultProps);
  var className = props.className,
    value = props.value,
    defaultValue = props.defaultValue,
    disabled = props.disabled,
    loading = props.loading,
    size = props.size,
    label = props.label,
    customValue = props.customValue,
    onChange = props.onChange,
    beforeChange = props.beforeChange,
    restProps = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var _ref = customValue || [],
    _ref2 = slicedToArray._slicedToArray(_ref, 2),
    _ref2$ = _ref2[0],
    activeValue = _ref2$ === void 0 ? true : _ref2$,
    _ref2$2 = _ref2[1],
    inactiveValue = _ref2$2 === void 0 ? false : _ref2$2;
  var isControlled = typeof value !== "undefined";
  var initChecked = defaultValue === activeValue || value === activeValue;
  var _useState = React.useState(initChecked),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    innerChecked = _useState2[0],
    setInnerChecked = _useState2[1];
  var contentNode = React__default["default"].useMemo(function () {
    if (Array.isArray(label)) {
      var _label = slicedToArray._slicedToArray(label, 2),
        _label$ = _label[0],
        activeContent = _label$ === void 0 ? "" : _label$,
        _label$2 = _label[1],
        inactiveContent = _label$2 === void 0 ? "" : _label$2;
      var content = innerChecked ? activeContent : inactiveContent;
      return _util_parseTNode["default"](content, {
        value: value
      });
    }
    return _util_parseTNode["default"](label, {
      value: value
    });
  }, [label, innerChecked, value]);
  var handleChange = function handleChange(e) {
    !isControlled && setInnerChecked(!innerChecked);
    var changedValue = !innerChecked ? activeValue : inactiveValue;
    onChange === null || onChange === void 0 || onChange(changedValue, {
      e: e
    });
  };
  var onInternalClick = function onInternalClick(e) {
    if (disabled) {
      return;
    }
    if (!beforeChange) {
      handleChange(e);
      return;
    }
    Promise.resolve(beforeChange()).then(function (v) {
      if (v) {
        handleChange(e);
      }
    })["catch"](function (e2) {
      log.log.error("Switch", "some error occurred: ".concat(e2));
    });
  };
  React.useEffect(function () {
    if (Array.isArray(customValue) && !customValue.includes(value)) {
      log.log.error("Switch", "value is not in customValue: ".concat(JSON.stringify(customValue)));
    }
    isControlled && setInnerChecked(value === activeValue);
  }, [value, customValue, activeValue, isControlled]);
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    SIZE = _useCommonClassName.SIZE,
    STATUS = _useCommonClassName.STATUS;
  var switchClassName = classNames__default["default"]("".concat(classPrefix, "-switch"), className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, STATUS.checked, innerChecked), STATUS.disabled, disabled), STATUS.loading, loading), SIZE[size]);
  return /* @__PURE__ */React__default["default"].createElement("button", _objectSpread(_objectSpread({}, restProps), {}, {
    type: "button",
    role: "switch",
    disabled: disabled || loading,
    className: switchClassName,
    ref: ref,
    onClick: onInternalClick
  }), /* @__PURE__ */React__default["default"].createElement("span", {
    className: "".concat(classPrefix, "-switch__handle")
  }, loading && /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, {
    loading: true,
    size: "small"
  })), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-switch__content")
  }, contentNode));
});
Switch.displayName = "Switch";

exports["default"] = Switch;
//# sourceMappingURL=Switch.js.map
