/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('../_chunks/dep-bbe52a2d.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var React = require('react');
var tdesignIconsReact = require('tdesign-icons-react');
var classNames = require('classnames');
var log = require('../_chunks/dep-53ae9438.js');
var popup_index = require('../popup/index.js');
var checkbox_index = require('../checkbox/index.js');
var radio_index = require('../radio/index.js');
var input_index = require('../input/index.js');
var button_index = require('../button/index.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var isEmpty = require('../_chunks/dep-064ecbe2.js');
require('../_chunks/dep-228d2001.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7e859ab6.js');
require('../_chunks/dep-53bbe417.js');
require('../hooks/useAnimation.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-f31a7521.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-a21132eb.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-1c5aedf3.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-41e5267c.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../common/Check.js');
require('../_chunks/dep-2a791a26.js');
require('../_util/helper.js');
require('../_chunks/dep-93919e5b.js');
require('../_chunks/dep-14fc6700.js');
require('../checkbox/defaultProps.js');
require('../_chunks/dep-dd0b0216.js');
require('../_chunks/dep-e53e2d3c.js');
require('../_chunks/dep-03e4a661.js');
require('../hooks/useCommonClassName.js');
require('../radio/defaultProps.js');
require('../radio/useKeyboard.js');
require('../_chunks/dep-ccc9685f.js');
require('../input/Input.js');
require('../input/InputGroup.js');
require('../input/defaultProps.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-b066e7ac.js');
require('../button/Button.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-91f34d3d.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../loading/gradient.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../button/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CheckboxGroup = checkbox_index.Checkbox.Group;
var RadioGroup = radio_index.Radio.Group;
function TableFilterController(props) {
  var tFilterValue = props.tFilterValue,
    innerFilterValue = props.innerFilterValue,
    tableFilterClasses = props.tableFilterClasses,
    isFocusClass = props.isFocusClass,
    column = props.column;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      FilterIcon: tdesignIconsReact.FilterIcon
    }),
    FilterIcon = _useGlobalIcon.FilterIcon;
  var triggerElementRef = React.useRef(null);
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("table"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    filterPopupVisible = _useState2[0],
    setFilterPopupVisible = _useState2[1];
  var onFilterPopupVisibleChange = function onFilterPopupVisibleChange(visible) {
    var _props$onVisibleChang;
    setFilterPopupVisible(visible);
    (_props$onVisibleChang = props.onVisibleChange) === null || _props$onVisibleChang === void 0 || _props$onVisibleChang.call(props, visible);
  };
  var getFilterContent = function getFilterContent(column2) {
    var _column2$filter, _column2$filter2, _column2$filter3, _column2$filter4, _column2$filter5;
    var types = ["single", "multiple", "input"];
    if (column2.type && !types.includes(column2.filter.type)) {
      log.log.error("Table", "TDesign Table Error: column.filter.type must be the following: ".concat(JSON.stringify(types)));
      return;
    }
    var Component = {
      single: RadioGroup,
      multiple: CheckboxGroup,
      input: input_index.Input
    }[column2.filter.type];
    if (!Component && !(column2 !== null && column2 !== void 0 && (_column2$filter = column2.filter) !== null && _column2$filter !== void 0 && _column2$filter.component)) return;
    var filterComponentProps = _objectSpread(_objectSpread({
      options: ["single", "multiple"].includes(column2.filter.type) ? (_column2$filter2 = column2.filter) === null || _column2$filter2 === void 0 ? void 0 : _column2$filter2.list : void 0
    }, ((_column2$filter3 = column2.filter) === null || _column2$filter3 === void 0 ? void 0 : _column2$filter3.props) || {}), {}, {
      onChange: function onChange(val) {
        var _props$onInnerFilterC;
        (_props$onInnerFilterC = props.onInnerFilterChange) === null || _props$onInnerFilterC === void 0 || _props$onInnerFilterC.call(props, val, column2);
      }
    });
    if (column2.colKey && innerFilterValue && column2.colKey in innerFilterValue) {
      filterComponentProps.value = innerFilterValue[column2.colKey];
    }
    if ((_column2$filter4 = column2.filter) !== null && _column2$filter4 !== void 0 && _column2$filter4.confirmEvents) {
      column2.filter.confirmEvents.forEach(function (event) {
        filterComponentProps[event] = function () {
          var _props$onConfirm;
          setFilterPopupVisible(false);
          (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 || _props$onConfirm.call(props, column2);
        };
      });
    }
    var FilterComponent = (column2 === null || column2 === void 0 || (_column2$filter5 = column2.filter) === null || _column2$filter5 === void 0 ? void 0 : _column2$filter5.component) || Component;
    var filter = column2.filter || {};
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: tableFilterClasses.contentInner
    }, /* @__PURE__ */React__default["default"].createElement(FilterComponent, _objectSpread(_objectSpread({
      className: filter.classNames,
      style: filter.style
    }, filter.attrs), filterComponentProps)));
  };
  var getBottomButtons = function getBottomButtons(column2) {
    if (!column2.filter.showConfirmAndReset) return;
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: tableFilterClasses.bottomButtons
    }, /* @__PURE__ */React__default["default"].createElement(button_index.Button, {
      theme: "default",
      size: "small",
      onClick: function onClick() {
        var _props$onReset;
        setFilterPopupVisible(false);
        (_props$onReset = props.onReset) === null || _props$onReset === void 0 || _props$onReset.call(props, column2);
      }
    }, locale.resetText), /* @__PURE__ */React__default["default"].createElement(button_index.Button, {
      theme: "primary",
      size: "small",
      onClick: function onClick() {
        var _props$onConfirm2;
        setFilterPopupVisible(false);
        (_props$onConfirm2 = props.onConfirm) === null || _props$onConfirm2 === void 0 || _props$onConfirm2.call(props, column2);
      }
    }, locale.confirmText));
  };
  if (!column.filter || column.filter && !Object.keys(column.filter).length) return null;
  var defaultFilterIcon = t(locale.filterIcon) || /* @__PURE__ */React__default["default"].createElement(FilterIcon, null);
  var filterValue = tFilterValue === null || tFilterValue === void 0 ? void 0 : tFilterValue[column.colKey];
  var isObjectTrue = _typeof._typeof(filterValue) === "object" && !isEmpty.isEmpty(filterValue);
  var isValueExist = ![null, void 0, ""].includes(filterValue) && _typeof._typeof(filterValue) !== "object";
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]([tableFilterClasses.icon, defineProperty._defineProperty({}, isFocusClass, isObjectTrue || isValueExist)])
  }, /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread({
    visible: filterPopupVisible,
    destroyOnClose: true,
    trigger: "click",
    placement: "bottom-right",
    showArrow: true,
    overlayClassName: tableFilterClasses.popup,
    onVisibleChange: function onVisibleChange(val) {
      return onFilterPopupVisibleChange(val);
    },
    content: /* @__PURE__ */React__default["default"].createElement("div", {
      className: tableFilterClasses.popupContent
    }, getFilterContent(column), getBottomButtons(column))
  }, props.popupProps), /* @__PURE__ */React__default["default"].createElement("div", {
    ref: triggerElementRef
  }, _util_parseTNode.parseContentTNode(props.filterIcon, {
    col: column,
    colIndex: props.colIndex
  }) || defaultFilterIcon)));
}

exports["default"] = TableFilterController;
//# sourceMappingURL=FilterController.js.map
