/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var classNames = require('classnames');
var table_utils = require('./utils.js');
var table_hooks_useFixed = require('./hooks/useFixed.js');
var table_hooks_useRowspanAndColspan = require('./hooks/useRowspanAndColspan.js');
var table_hooks_useClassName = require('./hooks/useClassName.js');
var isFunction = require('../_chunks/dep-decd1ba5.js');
var get = require('../_chunks/dep-65b91e54.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-a21132eb.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-dd0b0216.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-3949d9f0.js');
require('../_chunks/dep-53ae9438.js');
require('../_chunks/dep-e6a4e0ff.js');
require('../hooks/useDebounce.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../_chunks/dep-7e859ab6.js');
require('../hooks/usePrevious.js');
require('../_util/listener.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-c6162fd3.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-b275e705.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-9a247121.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-93a6e7a7.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-42e4b4c6.js');
require('../_chunks/dep-12bca1df.js');
require('../_chunks/dep-84fbcec5.js');
require('../_chunks/dep-2a9b9709.js');
require('../_chunks/dep-556420c0.js');
require('../_chunks/dep-b89fb5c8.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-e9e51520.js');
require('../_chunks/dep-3ae87727.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function TFoot(props) {
  var footData = props.footData,
    columns = props.columns,
    rowKey = props.rowKey,
    footerSummary = props.footerSummary,
    virtualScroll = props.virtualScroll;
  var tfooterRef = React.useRef(null);
  var classnames = table_hooks_useClassName["default"]();
  var _useRowspanAndColspan = table_hooks_useRowspanAndColspan["default"](footData, columns, rowKey, props.rowspanAndColspanInFooter),
    skipSpansMap = _useRowspanAndColspan.skipSpansMap;
  var renderTFootCell = function renderTFootCell(p) {
    var col = p.col,
      row = p.row;
    if (isFunction.isFunction(col.foot)) {
      return col.foot(p);
    }
    return col.foot || get.get(row, col.colKey);
  };
  var theadClasses = [classnames.tableFooterClasses.footer, defineProperty._defineProperty({}, classnames.tableFooterClasses.fixed, props.isFixedHeader)];
  if (!columns) return null;
  var footerDomList = footData === null || footData === void 0 ? void 0 : footData.map(function (row, rowIndex) {
    var trAttributes = table_utils.formatRowAttributes(props.rowAttributes, {
      row: row,
      rowIndex: rowIndex,
      type: "foot"
    });
    var customClasses = table_utils.formatRowClassNames(props.rowClassName, {
      row: row,
      rowIndex: rowIndex,
      type: "foot"
    }, props.rowKey || "id");
    return /* @__PURE__ */React__default["default"].createElement("tr", _objectSpread(_objectSpread({
      key: rowIndex
    }, trAttributes), {}, {
      className: classNames__default["default"](customClasses)
    }), columns.map(function (col, colIndex) {
      var _props$thWidthList;
      var cellSpans = {};
      var spanState = null;
      if (skipSpansMap.size) {
        var _spanState, _spanState2;
        var cellKey = table_hooks_useRowspanAndColspan.getCellKey(row, rowKey, col.colKey, colIndex);
        spanState = skipSpansMap.get(cellKey) || {};
        ((_spanState = spanState) === null || _spanState === void 0 ? void 0 : _spanState.rowspan) > 1 && (cellSpans.rowspan = spanState.rowspan);
        ((_spanState2 = spanState) === null || _spanState2 === void 0 ? void 0 : _spanState2.colspan) > 1 && (cellSpans.colspan = spanState.colspan);
        if (spanState.skipped) return null;
      }
      var tdStyles = table_hooks_useFixed.getColumnFixedStyles(col, colIndex, props.rowAndColFixedPosition, classnames.tableColFixedClasses);
      var style = _objectSpread({}, tdStyles.style);
      if ((_props$thWidthList = props.thWidthList) !== null && _props$thWidthList !== void 0 && _props$thWidthList[col.colKey]) {
        style.width = "".concat(props.thWidthList[col.colKey] || 0, "px");
      }
      return /* @__PURE__ */React__default["default"].createElement("td", {
        key: col.colKey,
        rowSpan: cellSpans.rowspan,
        colSpan: cellSpans.colspan,
        className: classNames__default["default"](tdStyles.classes),
        style: style
      }, renderTFootCell({
        row: row,
        rowIndex: rowIndex,
        col: col,
        colIndex: colIndex
      }));
    }));
  });
  if (!footerSummary && (!props.footData || !props.footData.length)) return null;
  return /* @__PURE__ */React__default["default"].createElement("tfoot", {
    ref: tfooterRef,
    className: classNames__default["default"](theadClasses),
    style: {
      visibility: virtualScroll ? "hidden" : "visible"
    }
  }, footerSummary && /* @__PURE__ */React__default["default"].createElement("tr", {
    className: classnames.tableFullRowClasses.base
  }, /* @__PURE__ */React__default["default"].createElement("td", {
    colSpan: columns.length
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classnames.tableFullRowClasses.innerFullElement
  }, footerSummary))), footerDomList);
}

exports["default"] = TFoot;
//# sourceMappingURL=TFoot.js.map
