/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../../_chunks/dep-a21132eb.js');
var defineProperty = require('../../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var React = require('react');
var utils = require('../../_chunks/dep-8c5b39c4.js');
var log = require('../../_chunks/dep-53ae9438.js');
var hooks_useControlled = require('../../hooks/useControlled.js');
var checkbox_index = require('../../checkbox/index.js');
var radio_index = require('../../radio/index.js');
var intersection = require('../../_chunks/dep-52e8a449.js');
var get = require('../../_chunks/dep-65b91e54.js');
var isFunction = require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_util/noop.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-41e5267c.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../common/Check.js');
require('../../_chunks/dep-2a791a26.js');
require('classnames');
require('../../_util/helper.js');
require('../../_chunks/dep-93919e5b.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../../_chunks/dep-14fc6700.js');
require('../../checkbox/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../_chunks/dep-dd0b0216.js');
require('../../_chunks/dep-e53e2d3c.js');
require('../../_chunks/dep-03e4a661.js');
require('../../hooks/useCommonClassName.js');
require('../../radio/defaultProps.js');
require('../../radio/useKeyboard.js');
require('../../_chunks/dep-ccc9685f.js');
require('../../_util/listener.js');
require('../../_chunks/dep-704d9321.js');
require('../../_chunks/dep-54722473.js');
require('../../_chunks/dep-0a55a910.js');
require('../../_chunks/dep-9a247121.js');
require('../../_chunks/dep-556420c0.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var selectedRowDataMap = /* @__PURE__ */new Map();
function useRowSelect(props, tableSelectedClasses) {
  var selectedRowKeys = props.selectedRowKeys,
    columns = props.columns,
    data = props.data,
    rowKey = props.rowKey,
    indeterminateSelectedRowKeys = props.indeterminateSelectedRowKeys;
  var pagination = props.pagination,
    reserveSelectedRowOnPaginate = props.reserveSelectedRowOnPaginate;
  var _useState = React.useState(data),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    currentPaginateData = _useState2[0],
    setCurrentPaginateData = _useState2[1];
  var _useState3 = React.useState(),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    selectedRowClassNames = _useState4[0],
    setSelectedRowClassNames = _useState4[1];
  var _useControlled = hooks_useControlled["default"](props, "selectedRowKeys", props.onSelectChange, {
      defaultSelectedRowKeys: props.defaultSelectedRowKeys || []
    }),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    tSelectedRowKeys = _useControlled2[0],
    setTSelectedRowKeys = _useControlled2[1];
  var selectColumn = columns.find(function (_ref) {
    var type = _ref.type;
    return ["multiple", "single"].includes(type);
  });
  var canSelectedRows = React.useMemo(function () {
    var currentData = reserveSelectedRowOnPaginate ? data : currentPaginateData;
    return (currentData === null || currentData === void 0 ? void 0 : currentData.filter(function (row, rowIndex) {
      return !isDisabled(row, rowIndex);
    })) || [];
  }, [reserveSelectedRowOnPaginate, data, currentPaginateData]);
  var intersectionKeys = intersection.intersection(tSelectedRowKeys, canSelectedRows.map(function (t) {
    return get.get(t, rowKey || "id");
  }));
  React.useEffect(function () {
    if (reserveSelectedRowOnPaginate) return;
    var pageSize = pagination.pageSize,
      current = pagination.current,
      defaultPageSize = pagination.defaultPageSize,
      defaultCurrent = pagination.defaultCurrent;
    var tPageSize = pageSize || defaultPageSize;
    var tCurrent = current || defaultCurrent;
    var newData = data.slice(tPageSize * (tCurrent - 1), tPageSize * tCurrent);
    setCurrentPaginateData(newData);
  }, [data, reserveSelectedRowOnPaginate]);
  React.useEffect(function () {
    if (!selectColumn && (!tSelectedRowKeys || !tSelectedRowKeys.length)) return;
    var disabledRowFunc = function disabledRowFunc(p) {
      return selectColumn.disabled(p) ? tableSelectedClasses.disabled : "";
    };
    var disabledRowClass = selectColumn !== null && selectColumn !== void 0 && selectColumn.disabled ? disabledRowFunc : void 0;
    var selected = new Set(tSelectedRowKeys);
    var selectedRowClassFunc = function selectedRowClassFunc(_ref2) {
      var row = _ref2.row;
      var rowId = get.get(row, rowKey || "id");
      return selected.has(rowId) ? tableSelectedClasses.selected : "";
    };
    var selectedRowClass = selected.size ? selectedRowClassFunc : void 0;
    setSelectedRowClassNames([disabledRowClass, selectedRowClass]);
  }, [data, columns, tSelectedRowKeys, selectColumn, rowKey]);
  function isDisabled(row, rowIndex) {
    return utils.isRowSelectedDisabled(selectColumn, row, rowIndex);
  }
  function getSelectedHeader() {
    return function () {
      var isIndeterminate = intersectionKeys.length > 0 && intersectionKeys.length < canSelectedRows.length;
      var isChecked = intersectionKeys.length !== 0 && canSelectedRows.length !== 0 && intersectionKeys.length === canSelectedRows.length;
      return /* @__PURE__ */React__default["default"].createElement(checkbox_index.Checkbox, {
        checked: isChecked,
        indeterminate: isIndeterminate,
        disabled: !canSelectedRows.length,
        onChange: handleSelectAll
      });
    };
  }
  function getRowSelectDisabledData(p) {
    var col = p.col,
      row = p.row,
      rowIndex = p.rowIndex;
    var disabled = typeof col.disabled === "function" ? col.disabled({
      row: row,
      rowIndex: rowIndex
    }) : col.disabled;
    var checkProps = isFunction.isFunction(col.checkProps) ? col.checkProps({
      row: row,
      rowIndex: rowIndex
    }) : col.checkProps;
    return {
      disabled: disabled || (checkProps === null || checkProps === void 0 ? void 0 : checkProps.disabled),
      checkProps: checkProps
    };
  }
  function renderSelectCell(p) {
    var column = p.col,
      _p$row = p.row,
      row = _p$row === void 0 ? {} : _p$row;
    var checked = tSelectedRowKeys.includes(get.get(row, rowKey || "id"));
    var _getRowSelectDisabled = getRowSelectDisabledData(p),
      disabled = _getRowSelectDisabled.disabled,
      checkProps = _getRowSelectDisabled.checkProps;
    var selectBoxProps = _objectSpread(_objectSpread({
      checked: checked,
      disabled: disabled
    }, checkProps), {}, {
      onChange: function onChange() {
        handleSelectChange(row);
      }
    });
    var onCheckClick = function onCheckClick(p2) {
      var e = "e" in p2 ? p2.e : p2;
      e === null || e === void 0 || e.stopPropagation();
    };
    if (column.type === "single") return /* @__PURE__ */React__default["default"].createElement(radio_index.Radio, _objectSpread(_objectSpread({}, selectBoxProps), {}, {
      onClick: onCheckClick
    }));
    if (column.type === "multiple") {
      var isIndeterminate = indeterminateSelectedRowKeys !== null && indeterminateSelectedRowKeys !== void 0 && indeterminateSelectedRowKeys.length ? indeterminateSelectedRowKeys.includes(get.get(row, rowKey)) : false;
      return /* @__PURE__ */React__default["default"].createElement(checkbox_index.Checkbox, _objectSpread(_objectSpread({
        indeterminate: isIndeterminate
      }, selectBoxProps), {}, {
        onClick: onCheckClick
      }));
    }
    return null;
  }
  var allowUncheck = React.useMemo(function () {
    var singleSelectCol = columns.find(function (col) {
      return col.type === "single";
    });
    if (!singleSelectCol || !singleSelectCol.checkProps || !("allowUncheck" in singleSelectCol.checkProps)) return false;
    return singleSelectCol.checkProps.allowUncheck;
  }, [columns]);
  function handleSelectChange() {
    var row = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var selectedRowKeys2 = toConsumableArray._toConsumableArray(tSelectedRowKeys);
    var reRowKey = rowKey || "id";
    var id = get.get(row, reRowKey);
    var selectedRowIndex = selectedRowKeys2.indexOf(id);
    var isExisted = selectedRowIndex !== -1;
    if (selectColumn.type === "multiple") {
      isExisted ? selectedRowKeys2.splice(selectedRowIndex, 1) : selectedRowKeys2.push(id);
    } else if (selectColumn.type === "single") {
      selectedRowKeys2 = isExisted && allowUncheck ? [] : [id];
    } else {
      log.log.warn("Table", "`column.type` must be one of `multiple` and `single`");
      return;
    }
    setTSelectedRowKeys(selectedRowKeys2, {
      selectedRowData: selectedRowKeys2.map(function (t) {
        return selectedRowDataMap.get(t);
      }),
      currentRowKey: id,
      currentRowData: row,
      type: isExisted ? "uncheck" : "check"
    });
  }
  function handleSelectAll(checked) {
    var reRowKey = rowKey || "id";
    var canSelectedRowKeys = canSelectedRows.map(function (record) {
      return get.get(record, reRowKey);
    });
    var disabledSelectedRowKeys = (selectedRowKeys === null || selectedRowKeys === void 0 ? void 0 : selectedRowKeys.filter(function (id) {
      return !canSelectedRowKeys.includes(id);
    })) || [];
    var allIds = checked ? [].concat(toConsumableArray._toConsumableArray(disabledSelectedRowKeys), toConsumableArray._toConsumableArray(canSelectedRowKeys)) : toConsumableArray._toConsumableArray(disabledSelectedRowKeys);
    setTSelectedRowKeys(allIds, {
      selectedRowData: checked ? allIds.map(function (t) {
        return selectedRowDataMap.get(t);
      }) : [],
      type: checked ? "check" : "uncheck",
      currentRowKey: "CHECK_ALL_BOX"
    });
  }
  function formatToRowSelectColumn(col) {
    var isSelection = ["multiple", "single"].includes(col.type);
    if (!isSelection) return col;
    return _objectSpread(_objectSpread({}, col), {}, {
      width: col.width || 64,
      className: tableSelectedClasses.checkCell,
      cell: function cell(p) {
        return renderSelectCell(p);
      },
      title: col.type === "multiple" ? getSelectedHeader() : col.title
    });
  }
  var onInnerSelectRowClick = function onInnerSelectRowClick(_ref3) {
    var row = _ref3.row,
      index = _ref3.index;
    var selectedColIndex = props.columns.findIndex(function (item) {
      return item.colKey === "row-select";
    });
    if (selectedColIndex === -1) return;
    var _getRowSelectDisabled2 = getRowSelectDisabledData({
        row: row,
        rowIndex: index,
        col: props.columns[selectedColIndex],
        colIndex: selectedColIndex
      }),
      disabled = _getRowSelectDisabled2.disabled;
    if (disabled) return;
    handleSelectChange(row);
  };
  React.useEffect(function () {
    for (var i = 0, len = data.length; i < len; i++) {
      selectedRowDataMap.set(get.get(data[i], rowKey || "id"), data[i]);
    }
  }, [data, rowKey]);
  return {
    selectedRowClassNames: selectedRowClassNames,
    currentPaginateData: currentPaginateData,
    setCurrentPaginateData: setCurrentPaginateData,
    setTSelectedRowKeys: setTSelectedRowKeys,
    formatToRowSelectColumn: formatToRowSelectColumn,
    onInnerSelectRowClick: onInnerSelectRowClick
  };
}

exports["default"] = useRowSelect;
//# sourceMappingURL=useRowSelect.js.map
