/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-fe81c65a.js');
var toConsumableArray = require('../../_chunks/dep-a21132eb.js');
var slicedToArray = require('../../_chunks/dep-3949d9f0.js');
var React = require('react');
var tdesignIconsReact = require('tdesign-icons-react');
var classNames = require('classnames');
var table_hooks_useTreeDataExpand = require('../../_chunks/dep-87c63f57.js');
var table_hooks_useClassName = require('./useClassName.js');
var table_Cell = require('../Cell.js');
var locale_LocalReceiver = require('../../locale/LocalReceiver.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var _util_parseTNode = require('../../_util/parseTNode.js');
var get = require('../../_chunks/dep-65b91e54.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-3dc69e9b.js');
require('../../_chunks/dep-8c5b39c4.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-53ae9438.js');
require('../../_chunks/dep-2360fa32.js');
require('../../_chunks/dep-4f8ba343.js');
require('../../_chunks/dep-b89fb5c8.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-556420c0.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../hooks/usePrevious.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-24195208.js');
require('../../_chunks/dep-737e4f38.js');
require('dayjs');
require('../../_chunks/dep-18f56df7.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-1f99f0e5.js');
require('../Ellipsis.js');
require('../../_util/scroll.js');
require('raf');
require('../../_chunks/dep-704d9321.js');
require('../../_chunks/dep-54722473.js');
require('../../_util/easing.js');
require('../../tooltip/index.js');
require('../../tooltip/Tooltip.js');
require('../../_chunks/dep-2a791a26.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('react-transition-group');
require('../../hooks/useAnimation.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../popup/hooks/useTrigger.js');
require('react-is');
require('../../_util/ref.js');
require('../../_util/isFragment.js');
require('../../_util/composeRefs.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../hooks/useMutationObserver.js');
require('../../hooks/useLatest.js');
require('../../_chunks/dep-f31a7521.js');
require('../../_chunks/dep-0a55a910.js');
require('../../_chunks/dep-12bca1df.js');
require('../../_chunks/dep-cf814f66.js');
require('../../_chunks/dep-7dbe9cf7.js');
require('../../_chunks/dep-bd900d58.js');
require('../../_chunks/dep-e24d1659.js');
require('../../_chunks/dep-df011d17.js');
require('../../_chunks/dep-0c1e22ea.js');
require('../../_chunks/dep-d5922382.js');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../hooks/useAttach.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../popup/PopupPlugin.js');
require('../../_chunks/dep-1c5aedf3.js');
require('../../_util/react-render.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-f0e94cb0.js');
require('../../_chunks/dep-cd4fa758.js');
require('../../tooltip/defaultProps.js');
require('../../tooltip/TooltipLite.js');
require('../../hooks/useSwitch.js');
require('../../hooks/usePersistFn.js');
require('../../_chunks/dep-6539e3d4.js');
require('../../hooks/useDebounce.js');
require('./useFixed.js');
require('../../_chunks/dep-b066e7ac.js');
require('../../_chunks/dep-dd0b0216.js');
require('../../_chunks/dep-e6a4e0ff.js');
require('../utils.js');
require('../../_chunks/dep-c6162fd3.js');
require('../../_chunks/dep-b275e705.js');
require('../../_chunks/dep-9a247121.js');
require('../../_chunks/dep-93a6e7a7.js');
require('../../_chunks/dep-42e4b4c6.js');
require('../../_chunks/dep-84fbcec5.js');
require('../../_chunks/dep-2a9b9709.js');
require('../../_chunks/dep-e9e51520.js');
require('../../_chunks/dep-3ae87727.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useTreeData(props) {
  var _props$tree;
  var data = props.data,
    columns = props.columns,
    tree = props.tree,
    rowKey = props.rowKey,
    treeExpandAndFoldIcon = props.treeExpandAndFoldIcon,
    expandedTreeNodes = props.expandedTreeNodes;
  var _useState = React.useState(function () {
      return new table_hooks_useTreeDataExpand.TableTreeStore();
    }),
    _useState2 = slicedToArray._slicedToArray(_useState, 1),
    store = _useState2[0];
  var _useState3 = React.useState(function () {
      return getTreeNodeColumnCol();
    }),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    treeNodeCol = _useState4[0],
    setTreeNodeCol = _useState4[1];
  var _useState5 = React.useState(data || []),
    _useState6 = slicedToArray._slicedToArray(_useState5, 2),
    dataSource = _useState6[0],
    setDataSource = _useState6[1];
  var _useClassName = table_hooks_useClassName["default"](),
    tableTreeClasses = _useClassName.tableTreeClasses;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("table"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      AddRectangleIcon: tdesignIconsReact.AddRectangleIcon,
      MinusRectangleIcon: tdesignIconsReact.MinusRectangleIcon
    }),
    AddRectangleIcon = _useGlobalIcon.AddRectangleIcon,
    MinusRectangleIcon = _useGlobalIcon.MinusRectangleIcon;
  var rowDataKeys = React.useMemo(function () {
    return {
      rowKey: rowKey || "id",
      childrenKey: (tree === null || tree === void 0 ? void 0 : tree.childrenKey) || "children"
    };
  }, [rowKey, tree === null || tree === void 0 ? void 0 : tree.childrenKey]);
  var _useState7 = React.useState(false),
    _useState8 = slicedToArray._slicedToArray(_useState7, 2),
    isDefaultExpandedTreeNodesExecute = _useState8[0],
    setIsDefaultExpandedTreeNodesExecute = _useState8[1];
  var _useTreeDataExpand = table_hooks_useTreeDataExpand.useTreeDataExpand(props, {
      store: store,
      dataSource: dataSource,
      rowDataKeys: rowDataKeys,
      setDataSource: setDataSource
    }),
    tExpandedTreeNode = _useTreeDataExpand.tExpandedTreeNode,
    isDefaultExpandAllExecute = _useTreeDataExpand.isDefaultExpandAllExecute,
    expandAll = _useTreeDataExpand.expandAll,
    foldAll = _useTreeDataExpand.foldAll,
    updateExpandOnDataChange = _useTreeDataExpand.updateExpandOnDataChange,
    onExpandFoldIconClick = _useTreeDataExpand.onExpandFoldIconClick;
  var checkedColumn = React.useMemo(function () {
    return columns.find(function (col) {
      return col.colKey === "row-select";
    });
  }, [columns]);
  React.useEffect(function () {
    if (!store || !checkedColumn) return;
    var rowValue = get.get(dataSource[0], rowDataKeys.rowKey);
    if (!store.treeDataMap.get(rowValue)) return;
    store.updateDisabledState(dataSource, checkedColumn, rowDataKeys);
  }, [checkedColumn]);
  React.useEffect(function () {
    if (!data || !store) return;
    if (tree) {
      resetData(data);
    } else {
      setDataSource(data);
    }
  }, [data, expandedTreeNodes]);
  React.useEffect(function () {
    var treeNodeColTmp = getTreeNodeColumnCol();
    setTreeNodeCol(treeNodeColTmp);
  }, [columns, (_props$tree = props.tree) === null || _props$tree === void 0 ? void 0 : _props$tree.treeNodeColumnIndex]);
  function resetData(data2) {
    var columns2 = props.columns,
      expandedTreeNodes2 = props.expandedTreeNodes,
      defaultExpandedTreeNodes = props.defaultExpandedTreeNodes;
    store.initialTreeStore(data2, columns2, rowDataKeys);
    var defaultNeedExpand = Boolean(!isDefaultExpandedTreeNodesExecute && (defaultExpandedTreeNodes === null || defaultExpandedTreeNodes === void 0 ? void 0 : defaultExpandedTreeNodes.length));
    var needExpandAll = Boolean((tree === null || tree === void 0 ? void 0 : tree.defaultExpandAll) && !isDefaultExpandAllExecute);
    if (tExpandedTreeNode !== null && tExpandedTreeNode !== void 0 && tExpandedTreeNode.length && !!(expandedTreeNodes2 || defaultNeedExpand) || needExpandAll) {
      updateExpandOnDataChange(toConsumableArray._toConsumableArray(data2));
      setIsDefaultExpandedTreeNodesExecute(true);
    } else {
      setDataSource(toConsumableArray._toConsumableArray(data2));
    }
  }
  function getTreeNodeStyle(level) {
    var _props$tree2, _props$tree3;
    if (level === void 0) return;
    var indent = ((_props$tree2 = props.tree) === null || _props$tree2 === void 0 ? void 0 : _props$tree2.indent) === void 0 ? 24 : (_props$tree3 = props.tree) === null || _props$tree3 === void 0 ? void 0 : _props$tree3.indent;
    return indent ? {
      paddingLeft: "".concat(level * indent || 1, "px")
    } : {};
  }
  function toggleExpandData(p, trigger) {
    var _props$onTreeExpandCh, _store$treeDataMap;
    var currentData = _objectSpread({}, p);
    if (p.row.__VIRTUAL_SCROLL_INDEX !== void 0) {
      currentData.rowIndex = p.row.__VIRTUAL_SCROLL_INDEX;
    }
    var newData = store.toggleExpandData(currentData, dataSource, rowDataKeys);
    setDataSource(toConsumableArray._toConsumableArray(newData));
    var rowValue = get.get(p.row, rowDataKeys.rowKey);
    (_props$onTreeExpandCh = props.onTreeExpandChange) === null || _props$onTreeExpandCh === void 0 || _props$onTreeExpandCh.call(props, {
      row: p.row,
      rowIndex: p.rowIndex,
      rowState: store === null || store === void 0 || (_store$treeDataMap = store.treeDataMap) === null || _store$treeDataMap === void 0 ? void 0 : _store$treeDataMap.get(rowValue),
      trigger: trigger
    });
  }
  function getTreeNodeColumnCol() {
    var _props$tree4;
    var columns2 = props.columns;
    var treeNodeColumnIndex = ((_props$tree4 = props.tree) === null || _props$tree4 === void 0 ? void 0 : _props$tree4.treeNodeColumnIndex) || 0;
    while ((_columns2$treeNodeCol = columns2[treeNodeColumnIndex]) !== null && _columns2$treeNodeCol !== void 0 && _columns2$treeNodeCol.type || ((_columns2$treeNodeCol2 = columns2[treeNodeColumnIndex]) === null || _columns2$treeNodeCol2 === void 0 ? void 0 : _columns2$treeNodeCol2.colKey) === "__EXPAND_ROW_ICON_COLUMN__") {
      var _columns2$treeNodeCol, _columns2$treeNodeCol2;
      treeNodeColumnIndex += 1;
    }
    return columns2[treeNodeColumnIndex];
  }
  function formatTreeColumn(col) {
    if (!col || !treeNodeCol || !store) return {};
    if (!props.tree || !Object.keys(props.tree).length || col.colKey !== treeNodeCol.colKey) return col;
    var newCol = _objectSpread({}, treeNodeCol);
    newCol.cell = function (p) {
      var cellInfo = table_Cell.renderCell(_objectSpread(_objectSpread({}, p), {}, {
        col: _objectSpread({}, treeNodeCol)
      }), {
        cellEmptyContent: props.cellEmptyContent
      });
      var currentState = store.treeDataMap.get(get.get(p.row, rowDataKeys.rowKey));
      var colStyle = getTreeNodeStyle(currentState === null || currentState === void 0 ? void 0 : currentState.level);
      var classes = defineProperty._defineProperty({}, tableTreeClasses.inlineCol, !!col.ellipsis);
      var childrenNodes = get.get(p.row, rowDataKeys.childrenKey);
      if (childrenNodes && childrenNodes instanceof Array || childrenNodes === true) {
        var _store$treeDataMap$ge;
        var expanded = (_store$treeDataMap$ge = store.treeDataMap.get(get.get(p.row, rowDataKeys.rowKey))) === null || _store$treeDataMap$ge === void 0 ? void 0 : _store$treeDataMap$ge.expanded;
        var type = expanded ? "fold" : "expand";
        var defaultIconNode = t(locale.treeExpandAndFoldIcon, {
          type: type
        }) || (expanded ? /* @__PURE__ */React__default["default"].createElement(MinusRectangleIcon, null) : /* @__PURE__ */React__default["default"].createElement(AddRectangleIcon, null));
        var iconNode = treeExpandAndFoldIcon ? _util_parseTNode.parseContentTNode(treeExpandAndFoldIcon, _objectSpread({
          type: type
        }, p)) : defaultIconNode;
        return /* @__PURE__ */React__default["default"].createElement("div", {
          className: classNames__default["default"]([tableTreeClasses.col, classes]),
          style: colStyle
        }, !!(childrenNodes.length || childrenNodes === true) && /* @__PURE__ */React__default["default"].createElement("span", {
          className: tableTreeClasses.icon,
          onClick: function onClick(e) {
            onExpandFoldIconClick(p, "expand-fold-icon");
            e.stopPropagation();
          }
        }, iconNode), cellInfo);
      }
      return /* @__PURE__ */React__default["default"].createElement("div", {
        style: colStyle,
        className: classNames__default["default"]([classes, tableTreeClasses.leafNode])
      }, /* @__PURE__ */React__default["default"].createElement("span", {
        className: tableTreeClasses.icon
      }), cellInfo);
    };
    if (newCol.ellipsis === true) {
      newCol.ellipsis = function (p) {
        return table_Cell.renderCell(_objectSpread(_objectSpread({}, p), {}, {
          col: _objectSpread({}, treeNodeCol)
        }));
      };
    }
    return newCol;
  }
  function setData(key, newRowData) {
    var rowIndex = store.updateData(key, newRowData, dataSource, rowDataKeys);
    var newData = toConsumableArray._toConsumableArray(dataSource);
    newData[rowIndex] = newRowData;
    setDataSource(toConsumableArray._toConsumableArray(newData));
  }
  function getData(key) {
    return store.getData(key);
  }
  function remove(key) {
    var newData = store.remove(key, dataSource, rowDataKeys);
    setDataSource(toConsumableArray._toConsumableArray(newData));
  }
  function removeChildren(key) {
    var newData = store.removeChildren(key, dataSource, rowDataKeys);
    setDataSource(toConsumableArray._toConsumableArray(newData));
  }
  function appendTo(key, newData) {
    if (!key) {
      setDataSource(toConsumableArray._toConsumableArray(store.appendToRoot(newData, dataSource, rowDataKeys)));
      return;
    }
    setDataSource(toConsumableArray._toConsumableArray(store.appendTo(key, newData, dataSource, rowDataKeys)));
  }
  function insertAfter(rowValue, newData) {
    setDataSource(toConsumableArray._toConsumableArray(store.insertAfter(rowValue, newData, dataSource, rowDataKeys)));
  }
  function insertBefore(rowValue, newData) {
    setDataSource(toConsumableArray._toConsumableArray(store.insertBefore(rowValue, newData, dataSource, rowDataKeys)));
  }
  function swapData(params) {
    var r = store.swapData(params.data, params, rowDataKeys);
    if (r.result) {
      setDataSource(toConsumableArray._toConsumableArray(r.dataSource));
    } else {
      var _props$onAbnormalDrag;
      var params2 = {
        code: r.code,
        reason: r.reason
      };
      (_props$onAbnormalDrag = props.onAbnormalDragSort) === null || _props$onAbnormalDrag === void 0 || _props$onAbnormalDrag.call(props, params2);
    }
  }
  function getTreeNode() {
    return store.getTreeNode(dataSource, rowDataKeys);
  }
  function getTreeExpandedRow() {
    var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "data";
    return store.getTreeExpandedRow(dataSource, rowDataKeys, type);
  }
  return {
    store: store,
    rowDataKeys: rowDataKeys,
    dataSource: dataSource,
    swapData: swapData,
    setData: setData,
    getData: getData,
    remove: remove,
    removeChildren: removeChildren,
    appendTo: appendTo,
    insertAfter: insertAfter,
    insertBefore: insertBefore,
    formatTreeColumn: formatTreeColumn,
    toggleExpandData: toggleExpandData,
    expandAll: expandAll,
    foldAll: foldAll,
    getTreeNode: getTreeNode,
    resetData: resetData,
    getTreeExpandedRow: getTreeExpandedRow,
    onExpandFoldIconClick: onExpandFoldIconClick
  };
}

exports["default"] = useTreeData;
//# sourceMappingURL=useTreeData.js.map
