/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var objectWithoutProperties = require('../_chunks/dep-2a791a26.js');
var React = require('react');
var classNames = require('classnames');
var common = require('../_chunks/dep-ccc9685f.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_noop = require('../_util/noop.js');
var tag_defaultProps = require('./defaultProps.js');
var tag_Tag = require('./Tag.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-7e859ab6.js');
require('../_chunks/dep-53bbe417.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('tdesign-icons-react');
require('tinycolor2');
require('../hooks/useGlobalIcon.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["value", "content", "onClick", "disabled", "children", "size", "checkedProps", "uncheckedProps", "onChange", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CheckTag = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, tag_defaultProps.checkTagDefaultProps);
  var value = props.value,
    content = props.content,
    _props$onClick = props.onClick,
    onClick = _props$onClick === void 0 ? _util_noop["default"] : _props$onClick,
    disabled = props.disabled,
    children = props.children,
    size = props.size,
    checkedProps = props.checkedProps,
    uncheckedProps = props.uncheckedProps,
    onChange = props.onChange,
    className = props.className,
    tagOtherProps = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var _useControlled = hooks_useControlled["default"](props, "checked", onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    innerChecked = _useControlled2[0],
    setInnerChecked = _useControlled2[1];
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var tagClassPrefix = "".concat(classPrefix, "-tag");
  var tagClass = React.useMemo(function () {
    return ["".concat(tagClassPrefix), "".concat(tagClassPrefix, "--check"), defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(tagClassPrefix, "--checked"), innerChecked), "".concat(tagClassPrefix, "--disabled"), disabled), "".concat(classPrefix, "-size-s"), size === "small"), "".concat(classPrefix, "-size-l"), size === "large"), className];
  }, [innerChecked, disabled, classPrefix, tagClassPrefix, size, className]);
  var checkTagProps = React.useMemo(function () {
    var tmpCheckedProps = _objectSpread({
      theme: "primary"
    }, checkedProps);
    var tmpUncheckedProps = _objectSpread({}, uncheckedProps);
    return innerChecked ? tmpCheckedProps : tmpUncheckedProps;
  }, [innerChecked, checkedProps, uncheckedProps]);
  var handleClick = function handleClick(_ref2) {
    var e = _ref2.e;
    if (!disabled) {
      onClick === null || onClick === void 0 || onClick({
        e: e
      });
      setInnerChecked(!innerChecked, {
        e: e,
        value: value
      });
    }
  };
  var keyboardEventListener = function keyboardEventListener(e) {
    var _e$key;
    var code = e.code || ((_e$key = e.key) === null || _e$key === void 0 ? void 0 : _e$key.trim());
    var isCheckedCode = common.SPACE_REG.test(code) || common.ENTER_REG.test(code);
    if (isCheckedCode) {
      e.preventDefault();
      setInnerChecked(!innerChecked, {
        e: e,
        value: value
      });
    }
  };
  var onCheckboxFocus = function onCheckboxFocus(e) {
    e.currentTarget.addEventListener("keydown", keyboardEventListener);
  };
  var onCheckboxBlur = function onCheckboxBlur(e) {
    e.currentTarget.removeEventListener("keydown", keyboardEventListener);
  };
  return /* @__PURE__ */React__default["default"].createElement(tag_Tag.Tag, _objectSpread(_objectSpread({
    ref: ref,
    className: classNames__default["default"](tagClass),
    disabled: props.disabled,
    tabIndex: props.disabled ? void 0 : 0,
    onFocus: onCheckboxFocus,
    onBlur: onCheckboxBlur
  }, checkTagProps), {}, {
    onClick: handleClick
  }, tagOtherProps), content || children);
});
CheckTag.displayName = "CheckTag";

exports["default"] = CheckTag;
//# sourceMappingURL=CheckTag.js.map
