/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-fe81c65a.js');
var React = require('react');
var isEmpty = require('../_chunks/dep-064ecbe2.js');
var isString = require('../_chunks/dep-54722473.js');
var isFunction = require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-53bbe417.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-df011d17.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-5bb0ceb3.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var getDefaultValue = function getDefaultValue(value, defaultValue) {
  if (isEmpty.isEmpty(value)) {
    return Array.isArray(defaultValue) ? defaultValue : [defaultValue, defaultValue];
  }
  if (Array.isArray(value)) return value;
  return [defaultValue, defaultValue];
};
var getJSX = function getJSX(value) {
  if (isString.isString(value)) return value;
  if (isFunction.isFunction(value)) return value();
  if (/*#__PURE__*/React__default["default"].isValidElement(value)) return value;
  return value;
};
var getLeafNodes = function getLeafNodes(nodes) {
  var resData = [];
  var _map = function map(nodes2) {
    nodes2.forEach(function (child) {
      if (child.children && child.children.length > 0) {
        return _map(child.children);
      }
      resData.push(child);
    });
  };
  _map(nodes);
  return resData;
};
var _filterCheckedTreeNodes = function filterCheckedTreeNodes(nodes, checkeds) {
  return nodes.filter(function (item) {
    return !checkeds.includes(item.value);
  }).map(function (item) {
    var newItem = _objectSpread({}, item);
    if (item.children && item.children.length > 0) {
      newItem.children = _filterCheckedTreeNodes(item.children, checkeds);
    }
    return newItem;
  }).filter(function (item) {
    return item.children && item.children.length !== 0 || !item.children;
  });
};
var getTargetNodes = function getTargetNodes(sourceNodes, data) {
  var source = getLeafNodes(sourceNodes).map(function (item) {
    return item.value;
  });
  return _filterCheckedTreeNodes(data, source);
};

exports.filterCheckedTreeNodes = _filterCheckedTreeNodes;
exports.getDefaultValue = getDefaultValue;
exports.getJSX = getJSX;
exports.getLeafNodes = getLeafNodes;
exports.getTargetNodes = getTargetNodes;
//# sourceMappingURL=utils.js.map
