/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-fe81c65a.js');
var React = require('react');
var treeStore = require('../../_chunks/dep-354a0f13.js');
var hooks_usePersistFn = require('../../hooks/usePersistFn.js');
var treeSelect_defaultProps = require('../defaultProps.js');
require('../../_chunks/dep-bbe52a2d.js');
require('../../_chunks/dep-3dc69e9b.js');
require('mitt');
require('../../_chunks/dep-bb95b18b.js');
require('../../_chunks/dep-1c5aedf3.js');
require('../../_chunks/dep-a21132eb.js');
require('../../_chunks/dep-228d2001.js');
require('../../_chunks/dep-53ae9438.js');
require('../../_chunks/dep-2a9b9709.js');
require('../../_chunks/dep-556420c0.js');
require('../../_chunks/dep-5bb0ceb3.js');
require('../../_chunks/dep-7e859ab6.js');
require('../../_chunks/dep-7ffe7abb.js');
require('../../_chunks/dep-53bbe417.js');
require('../../_chunks/dep-01c97e2a.js');
require('../../_chunks/dep-3963da7e.js');
require('../../_chunks/dep-decd1ba5.js');
require('../../_chunks/dep-3561ed02.js');
require('../../_chunks/dep-d788c41a.js');
require('../../_chunks/dep-4b5c6368.js');
require('../../_chunks/dep-b89fb5c8.js');
require('../../_chunks/dep-a68b527a.js');
require('../../_chunks/dep-5522bd43.js');
require('../../_chunks/dep-5267fa9b.js');
require('../../_chunks/dep-e9e51520.js');
require('../../_chunks/dep-07098818.js');
require('../../_chunks/dep-f8271f08.js');
require('../../_chunks/dep-3ae87727.js');
require('../../_chunks/dep-93a6e7a7.js');
require('../../_chunks/dep-7dbe9cf7.js');
require('../../_chunks/dep-40e0109f.js');
require('../../_chunks/dep-14fc6700.js');
require('../../_chunks/dep-013699bc.js');
require('../../_chunks/dep-cd4fa758.js');
require('../../_chunks/dep-db3b17d7.js');
require('../../_chunks/dep-7a979ab0.js');
require('../../_chunks/dep-77923495.js');
require('../../_chunks/dep-ad2351bc.js');
require('../../_chunks/dep-cf814f66.js');
require('../../_chunks/dep-bd900d58.js');
require('../../_chunks/dep-e24d1659.js');
require('../../_chunks/dep-df011d17.js');
require('../../_chunks/dep-84fbcec5.js');
require('../../_chunks/dep-d4f8f0c4.js');
require('../../_chunks/dep-86086537.js');
require('../../_chunks/dep-2360fa32.js');
require('../../_chunks/dep-dd0b0216.js');
require('../../_chunks/dep-65b91e54.js');
require('../../_chunks/dep-805fcdb5.js');
require('../../_chunks/dep-5669eec6.js');
require('../../_chunks/dep-54722473.js');
require('../../_chunks/dep-3e9ca68a.js');
require('../../_chunks/dep-b275e705.js');
require('../../_chunks/dep-0a55a910.js');
require('../../_chunks/dep-9a247121.js');
require('../../_chunks/dep-d6f2b851.js');
require('../../_chunks/dep-93919e5b.js');
require('../../_chunks/dep-42d7bed5.js');
require('../../_chunks/dep-006f8a6d.js');

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var useTreeSelectUtils = function useTreeSelectUtils(_ref, treeRef) {
  var data = _ref.data,
    treeProps = _ref.treeProps,
    valueType = _ref.valueType;
  var defaultStore = React.useMemo(function () {
    var store = new treeStore.TreeStore(_objectSpread(_objectSpread({}, treeSelect_defaultProps.treeSelectDefaultProps.treeProps), treeProps));
    store.append(data);
    return store;
  }, [data, treeProps]);
  var getNodeItem = hooks_usePersistFn.usePersistFn(function (value) {
    var _defaultStore$getNode;
    if (treeRef.current) {
      return treeRef.current.getItem(value);
    }
    return (_defaultStore$getNode = defaultStore.getNode(value)) === null || _defaultStore$getNode === void 0 ? void 0 : _defaultStore$getNode.getModel();
  });
  var formatValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value, _treeProps$keys, _treeProps$keys$label, _treeProps$keys2;
    var label = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : String(value);
    var valueKey = (_treeProps$keys$value = treeProps === null || treeProps === void 0 || (_treeProps$keys = treeProps.keys) === null || _treeProps$keys === void 0 ? void 0 : _treeProps$keys.value) !== null && _treeProps$keys$value !== void 0 ? _treeProps$keys$value : "value";
    var labelKey = (_treeProps$keys$label = treeProps === null || treeProps === void 0 || (_treeProps$keys2 = treeProps.keys) === null || _treeProps$keys2 === void 0 ? void 0 : _treeProps$keys2.label) !== null && _treeProps$keys$label !== void 0 ? _treeProps$keys$label : "label";
    return value && valueType === "object" ? defineProperty._defineProperty(defineProperty._defineProperty({}, valueKey, value), labelKey, label) : value;
  });
  var normalizeValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value2, _treeProps$keys3, _treeProps$keys$label2, _treeProps$keys4, _ref3, _node$label;
    var valueKey = (_treeProps$keys$value2 = treeProps === null || treeProps === void 0 || (_treeProps$keys3 = treeProps.keys) === null || _treeProps$keys3 === void 0 ? void 0 : _treeProps$keys3.value) !== null && _treeProps$keys$value2 !== void 0 ? _treeProps$keys$value2 : "value";
    var labelKey = (_treeProps$keys$label2 = treeProps === null || treeProps === void 0 || (_treeProps$keys4 = treeProps.keys) === null || _treeProps$keys4 === void 0 ? void 0 : _treeProps$keys4.label) !== null && _treeProps$keys$label2 !== void 0 ? _treeProps$keys$label2 : "label";
    var realValue = valueType === "value" ? value : value === null || value === void 0 ? void 0 : value[valueKey];
    var node = getNodeItem(realValue);
    var realLabel = valueType === "object" ? value === null || value === void 0 ? void 0 : value[labelKey] : void 0;
    return {
      value: realValue,
      label: (_ref3 = (_node$label = node === null || node === void 0 ? void 0 : node.label) !== null && _node$label !== void 0 ? _node$label : realLabel) !== null && _ref3 !== void 0 ? _ref3 : String(realValue)
    };
  });
  return {
    getNodeItem: getNodeItem,
    formatValue: formatValue,
    normalizeValue: normalizeValue
  };
};

exports.useTreeSelectUtils = useTreeSelectUtils;
//# sourceMappingURL=useTreeSelectUtils.js.map
