/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-a21132eb.js');
var defineProperty = require('../_chunks/dep-fe81c65a.js');
var slicedToArray = require('../_chunks/dep-3949d9f0.js');
var React = require('react');
var reactTransitionGroup = require('react-transition-group');
var classNames = require('classnames');
var log = require('../_chunks/dep-53ae9438.js');
var tree_TreeItem = require('./TreeItem.js');
var tree_hooks_useControllable = require('./hooks/useControllable.js');
var tree_hooks_useStore = require('./hooks/useStore.js');
var tree_hooks_useTreeConfig = require('./hooks/useTreeConfig.js');
var tree_hooks_TreeDraggableContext = require('./hooks/TreeDraggableContext.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var hooks_usePersistFn = require('../hooks/usePersistFn.js');
var tree_hooks_useTreeVirtualScroll = require('./hooks/useTreeVirtualScroll.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var get = require('../_chunks/dep-65b91e54.js');
require('../_chunks/dep-228d2001.js');
require('../_chunks/dep-bbe52a2d.js');
require('../_chunks/dep-2a791a26.js');
require('tdesign-icons-react');
require('../loading/index.js');
require('../loading/Loading.js');
require('../_chunks/dep-704d9321.js');
require('../_chunks/dep-54722473.js');
require('../_chunks/dep-7ffe7abb.js');
require('../_chunks/dep-5bb0ceb3.js');
require('../_chunks/dep-53bbe417.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-24195208.js');
require('../_chunks/dep-737e4f38.js');
require('dayjs');
require('../_chunks/dep-18f56df7.js');
require('../_chunks/dep-db3b17d7.js');
require('../_chunks/dep-07098818.js');
require('../_chunks/dep-7a979ab0.js');
require('../_chunks/dep-f8271f08.js');
require('../_chunks/dep-decd1ba5.js');
require('../_chunks/dep-3561ed02.js');
require('../_chunks/dep-77923495.js');
require('../_chunks/dep-5267fa9b.js');
require('../_chunks/dep-01c97e2a.js');
require('../_chunks/dep-3963da7e.js');
require('../_chunks/dep-d788c41a.js');
require('../_chunks/dep-a68b527a.js');
require('../_chunks/dep-5522bd43.js');
require('../_chunks/dep-ad2351bc.js');
require('../_chunks/dep-d6f2b851.js');
require('../_chunks/dep-40e0109f.js');
require('../_chunks/dep-86086537.js');
require('../_chunks/dep-1f99f0e5.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-91f34d3d.js');
require('../_chunks/dep-b066e7ac.js');
require('../_chunks/dep-dd0b0216.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-1c5aedf3.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-f0e94cb0.js');
require('../_chunks/dep-cd4fa758.js');
require('../_chunks/dep-cf814f66.js');
require('../_chunks/dep-7dbe9cf7.js');
require('../_chunks/dep-bd900d58.js');
require('../_chunks/dep-e24d1659.js');
require('../_chunks/dep-df011d17.js');
require('../hooks/useRipple.js');
require('../hooks/useAnimation.js');
require('../hooks/useGlobalIcon.js');
require('../checkbox/index.js');
require('../_chunks/dep-41e5267c.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../common/Check.js');
require('../_util/helper.js');
require('../_chunks/dep-93919e5b.js');
require('../_chunks/dep-4b5c6368.js');
require('../_chunks/dep-7e859ab6.js');
require('../_chunks/dep-42d7bed5.js');
require('../_chunks/dep-006f8a6d.js');
require('../_chunks/dep-d4f8f0c4.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-14fc6700.js');
require('../checkbox/defaultProps.js');
require('./hooks/useDraggable.js');
require('../_chunks/dep-6539e3d4.js');
require('../_chunks/dep-0c1e22ea.js');
require('../_chunks/dep-d5922382.js');
require('../_util/composeRefs.js');
require('../_chunks/dep-354a0f13.js');
require('../_chunks/dep-3dc69e9b.js');
require('mitt');
require('../_chunks/dep-bb95b18b.js');
require('../_chunks/dep-2a9b9709.js');
require('../_chunks/dep-556420c0.js');
require('../_chunks/dep-b89fb5c8.js');
require('../_chunks/dep-e9e51520.js');
require('../_chunks/dep-3ae87727.js');
require('../_chunks/dep-93a6e7a7.js');
require('../_chunks/dep-013699bc.js');
require('../_chunks/dep-84fbcec5.js');
require('../_chunks/dep-2360fa32.js');
require('../_chunks/dep-805fcdb5.js');
require('../_chunks/dep-5669eec6.js');
require('../_chunks/dep-3e9ca68a.js');
require('../_chunks/dep-b275e705.js');
require('../_chunks/dep-0a55a910.js');
require('../_chunks/dep-9a247121.js');
require('../hooks/useUpdateLayoutEffect.js');
require('../hooks/useIsFirstRender.js');
require('../hooks/usePrevious.js');
require('../locale/LocalReceiver.js');
require('../_util/createHookContext.js');
require('../hooks/useVirtualScroll.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLatest.js');
require('../hooks/useEventCallback.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Tree = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var _useTreeConfig = tree_hooks_useTreeConfig.useTreeConfig(),
    treeClassNames = _useTreeConfig.treeClassNames,
    transitionNames = _useTreeConfig.transitionNames,
    transitionClassNames = _useTreeConfig.transitionClassNames,
    transitionDuration = _useTreeConfig.transitionDuration,
    locale = _useTreeConfig.locale;
  var props = hooks_useDefaultProps["default"](originalProps, {
    data: [],
    expandLevel: 0,
    icon: true,
    line: false,
    transition: true,
    lazy: true,
    valueMode: "onlyLeaf"
  });
  var _useState = React.useState([]),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    visibleNodes = _useState2[0],
    setVisibleNodes = _useState2[1];
  var empty = props.empty,
    activable = props.activable,
    disabled = props.disabled,
    checkable = props.checkable,
    checkProps = props.checkProps,
    disableCheck = props.disableCheck,
    hover = props.hover,
    icon = props.icon,
    line = props.line,
    label = props.label,
    operations = props.operations,
    transition = props.transition,
    expandOnClickNode = props.expandOnClickNode,
    onClick = props.onClick,
    scroll = props.scroll,
    className = props.className,
    style = props.style,
    allowDrop = props.allowDrop,
    onScroll = props.onScroll;
  var _useControllable = tree_hooks_useControllable["default"](props),
    value = _useControllable.value,
    onChange = _useControllable.onChange,
    expanded = _useControllable.expanded,
    onExpand = _useControllable.onExpand,
    onActive = _useControllable.onActive,
    actived = _useControllable.actived,
    setTreeIndeterminate = _useControllable.setTreeIndeterminate,
    indeterminate = _useControllable.indeterminate;
  var emptyText = locale("empty");
  var store = tree_hooks_useStore.useStore(_objectSpread(_objectSpread({}, props), {}, {
    value: value,
    onChange: onChange,
    expanded: expanded,
    onExpand: onExpand,
    onActive: onActive,
    actived: actived,
    indeterminate: indeterminate,
    setTreeIndeterminate: setTreeIndeterminate
  }), initial);
  function initial() {
    var nodes = store === null || store === void 0 ? void 0 : store.getNodes();
    var newVisibleNodes = nodes === null || nodes === void 0 ? void 0 : nodes.filter(function (node) {
      return node.visible;
    });
    setVisibleNodes(newVisibleNodes);
  }
  var setExpanded = hooks_usePersistFn.usePersistFn(function (node, isExpanded, ctx) {
    var e = ctx.e,
      trigger = ctx.trigger;
    var expanded2 = node.setExpanded(isExpanded);
    var treeNodeModel = node === null || node === void 0 ? void 0 : node.getModel();
    (e || trigger) && (onExpand === null || onExpand === void 0 ? void 0 : onExpand(expanded2, {
      node: treeNodeModel,
      e: e,
      trigger: trigger
    }));
    return expanded2;
  });
  var setIndeterminate = hooks_usePersistFn.usePersistFn(function (node, isIndeterminate, ctx) {
    ctx.e;
      ctx.trigger;
    var indeterminate2 = node.setIndeterminate(isIndeterminate);
    return indeterminate2;
  });
  var treeRef = React.useRef(null);
  var _useTreeVirtualScroll = tree_hooks_useTreeVirtualScroll["default"]({
      treeRef: treeRef,
      scroll: scroll,
      data: visibleNodes,
      onScroll: onScroll
    }),
    visibleData = _useTreeVirtualScroll.visibleData,
    isVirtual = _useTreeVirtualScroll.isVirtual,
    virtualTreeNodeStyle = _useTreeVirtualScroll.treeNodeStyle,
    cursorStyle = _useTreeVirtualScroll.cursorStyle,
    handleRowMounted = _useTreeVirtualScroll.handleRowMounted,
    scrollToElement = _useTreeVirtualScroll.scrollToElement;
  var setActived = hooks_usePersistFn.usePersistFn(function (node, isActived, ctx) {
    var actived2 = node.setActived(isActived);
    var treeNodeModel = node === null || node === void 0 ? void 0 : node.getModel();
    onActive === null || onActive === void 0 || onActive(actived2, _objectSpread({
      node: treeNodeModel
    }, ctx));
    return actived2;
  });
  var setChecked = hooks_usePersistFn.usePersistFn(function (node, isChecked, ctx) {
    var checked = node.setChecked(isChecked);
    var treeNodeModel = node === null || node === void 0 ? void 0 : node.getModel();
    onChange === null || onChange === void 0 || onChange(checked, _objectSpread({
      node: treeNodeModel
    }, ctx));
    return checked;
  });
  var handleItemClick = function handleItemClick(node, options) {
    if (!node) {
      return;
    }
    var isDisabled = disabled || node.disabled;
    var expand = options.expand,
      active = options.active,
      e = options.e,
      trigger = options.trigger;
    if (expand) setExpanded(node, !node.isExpanded(), {
      e: e,
      trigger: trigger
    });
    if (!isDisabled) {
      var treeNodeModel = node === null || node === void 0 ? void 0 : node.getModel();
      if (active) {
        setActived(node, !node.isActived(), {
          e: e,
          trigger: "node-click"
        });
        onClick === null || onClick === void 0 || onClick({
          node: treeNodeModel,
          e: e
        });
      } else {
        onClick === null || onClick === void 0 || onClick({
          node: treeNodeModel,
          e: e
        });
      }
    }
  };
  var handleChange = function handleChange(node, ctx) {
    if (!node || disabled || node.disabled) {
      return;
    }
    setChecked(node, !node.isChecked(), _objectSpread(_objectSpread({}, ctx), {}, {
      trigger: "node-click"
    }));
  };
  var handleScrollToElement = React.useCallback(function (params) {
    var index = params.index;
    if (!index && index !== 0) {
      if (!params.key) {
        log.log.error("Tree", "scrollToElement: one of `index` or `key` must exist.");
        return;
      }
      var data = visibleNodes;
      index = data === null || data === void 0 ? void 0 : data.findIndex(function (item) {
        return [get.get(item.data, "key"), get.get(item.data, "value")].includes(params.key);
      });
      if (index < 0) {
        log.log.error("Tree", "".concat(params.key, " does not exist in data, check `key` or `data` please."));
      }
    }
    scrollToElement(_objectSpread(_objectSpread({}, params), {}, {
      index: index
    }));
  }, [scrollToElement, visibleNodes]);
  React.useImperativeHandle(ref, function () {
    return {
      store: store,
      scrollTo: function scrollTo(p) {
        return handleScrollToElement(p);
      },
      appendTo: function appendTo(value2, newData) {
        var list = [];
        if (Array.isArray(newData)) {
          list = newData;
        } else {
          list = [newData];
        }
        list.forEach(function (item) {
          store.appendNodes(value2, item);
        });
      },
      getIndex: function getIndex(value2) {
        return store.getNodeIndex(value2);
      },
      getItem: function getItem(value2) {
        var node = store.getNode(value2);
        return node === null || node === void 0 ? void 0 : node.getModel();
      },
      getItems: function getItems(value2) {
        var nodes = store.getNodes(value2);
        return nodes.map(function (node) {
          return node.getModel();
        });
      },
      getParent: function getParent(value2) {
        var node = store.getParent(value2);
        return node === null || node === void 0 ? void 0 : node.getModel();
      },
      getParents: function getParents(value2) {
        var nodes = store.getParents(value2);
        return nodes.map(function (node) {
          return node.getModel();
        });
      },
      getPath: function getPath(value2) {
        var node = store.getNode(value2);
        var pathNodes = [];
        if (node) {
          pathNodes = node.getPath().map(function (node2) {
            return node2.getModel();
          });
        }
        return pathNodes;
      },
      insertAfter: function insertAfter(value2, newData) {
        return store.insertAfter(value2, newData);
      },
      insertBefore: function insertBefore(value2, newData) {
        return store.insertBefore(value2, newData);
      },
      remove: function remove(value2) {
        return store.remove(value2);
      },
      setItem: function setItem(value2, options) {
        var node = this.store.getNode(value2);
        var spec = options;
        if (node && spec) {
          if ("expanded" in options) {
            setExpanded(node, spec.expanded, {
              trigger: "setItem"
            });
            delete spec.expanded;
          }
          if ("actived" in options) {
            setActived(node, spec.actived, {
              trigger: "setItem"
            });
            delete spec.actived;
          }
          if ("checked" in options) {
            setChecked(node, spec.checked, {
              trigger: "setItem"
            });
            delete spec.checked;
          }
          if ("indeterminate" in options) {
            setTreeIndeterminate(function (prevIndeterminate) {
              return [].concat(toConsumableArray._toConsumableArray(prevIndeterminate), [value2]);
            });
            setIndeterminate(node, spec.indeterminate, {
              trigger: "setItem"
            });
            delete spec.indeterminate;
          }
          node.set(spec);
        }
      }
    };
  }, [store, setExpanded, setActived, setTreeIndeterminate, setChecked, setIndeterminate, handleScrollToElement]);
  var nodeList = React.useMemo(function () {
    return visibleNodes.map(function () {
      return /*#__PURE__*/React__default["default"].createRef();
    });
  }, [visibleNodes]);
  var renderEmpty = function renderEmpty() {
    return _util_parseTNode["default"](empty, null, emptyText);
  };
  var renderItems = function renderItems(renderNode) {
    if (renderNode.length <= 0) {
      return renderEmpty();
    }
    if (isVirtual) return /* @__PURE__ */React__default["default"].createElement("div", {
      className: treeClassNames.treeList,
      style: virtualTreeNodeStyle
    }, renderNode.map(function (node, index) {
      return /* @__PURE__ */React__default["default"].createElement(tree_TreeItem["default"], {
        ref: nodeList[index],
        key: node.value,
        node: node,
        keys: props.keys,
        empty: empty,
        icon: icon,
        label: label,
        line: line,
        allowDrop: allowDrop,
        transition: transition,
        expandOnClickNode: expandOnClickNode,
        activable: activable,
        operations: operations,
        checkProps: checkProps,
        disableCheck: disableCheck,
        onClick: handleItemClick,
        onChange: handleChange,
        onTreeItemMounted: handleRowMounted,
        isVirtual: isVirtual
      });
    }));
    return /* @__PURE__ */React__default["default"].createElement(reactTransitionGroup.TransitionGroup, {
      name: transitionNames.treeNode,
      className: treeClassNames.treeList
    }, renderNode.map(function (node, index) {
      return /* @__PURE__ */React__default["default"].createElement(reactTransitionGroup.CSSTransition, {
        nodeRef: nodeList[index],
        key: node.value,
        timeout: transitionDuration,
        classNames: transitionClassNames
      }, /* @__PURE__ */React__default["default"].createElement(tree_TreeItem["default"], {
        ref: nodeList[index],
        node: node,
        keys: props.keys,
        empty: empty,
        icon: icon,
        label: label,
        line: line,
        allowDrop: allowDrop,
        transition: transition,
        expandOnClickNode: expandOnClickNode,
        activable: activable,
        operations: operations,
        checkProps: checkProps,
        disableCheck: disableCheck,
        onClick: handleItemClick,
        onChange: handleChange
      }));
    }));
  };
  var draggable = React.useMemo(function () {
    return {
      props: props,
      store: store
    };
  }, [props, store]);
  return /* @__PURE__ */React__default["default"].createElement(tree_hooks_TreeDraggableContext.TreeDraggableContext.Provider, {
    value: draggable
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](treeClassNames.tree, className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, treeClassNames.disabled, disabled), treeClassNames.treeHoverable, hover), treeClassNames.treeCheckable, checkable), treeClassNames.treeFx, transition), treeClassNames.treeBlockNode, expandOnClickNode), treeClassNames.treeVscroll, props.scroll)),
    style: style,
    ref: treeRef
  }, isVirtual ? /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */React__default["default"].createElement("div", {
    className: treeClassNames.treeVscrollCursor,
    style: cursorStyle
  }), renderItems(visibleData)) : renderItems(visibleNodes)));
});
Tree.displayName = "Tree";

exports["default"] = Tree;
//# sourceMappingURL=Tree.js.map
