/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import DatePickerFooter from '../base/Footer.js';
import '../../_chunks/dep-4570e07f.js';
import '../../_chunks/dep-d9ee0736.js';
import '../../_chunks/dep-c4282af8.js';
import '../../_chunks/dep-872e77c8.js';
import 'classnames';
import '../../locale/LocalReceiver.js';
import '../../config-provider/index.js';
import '../../config-provider/ConfigProvider.js';
import 'lodash-es';
import '../../config-provider/ConfigContext.js';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-097b28c0.js';
import 'dayjs';
import '../../_chunks/dep-59cb926b.js';
import '../../config-provider/type.js';
import '../../button/index.js';
import '../../button/Button.js';
import '../../_chunks/dep-f20b5e73.js';
import '../../hooks/useConfig.js';
import '../../hooks/useDomRefCallback.js';
import '../../hooks/useRipple.js';
import '../../_chunks/dep-f0b5ab03.js';
import '../../hooks/useAnimation.js';
import '../../_chunks/dep-c514bb1c.js';
import '../../loading/index.js';
import '../../loading/Loading.js';
import '../../common/Portal.js';
import 'react-dom';
import '../../hooks/useLayoutEffect.js';
import '../../loading/gradient.js';
import '../../_chunks/dep-c003e88d.js';
import '../../_chunks/dep-759f5bcf.js';
import '../../loading/defaultProps.js';
import '../../hooks/useDefaultProps.js';
import '../../loading/plugin.js';
import '../../_util/react-render.js';
import '../../_chunks/dep-9482371f.js';
import '../../common/PluginContainer.js';
import '../../loading/style/css.js';
import '../../loading/type.js';
import '../../button/defaultProps.js';
import '../../_util/parseTNode.js';
import '../../_chunks/dep-ecbbcdbe.js';
import '../../_chunks/dep-653e29e9.js';
import '../../button/style/css.js';
import '../../button/type.js';

function ExtraContent(props) {
  var presets = props.presets,
    enableTimePicker = props.enableTimePicker,
    presetsPlacement = props.presetsPlacement,
    onPresetClick = props.onPresetClick,
    onConfirmClick = props.onConfirmClick,
    selectedValue = props.selectedValue,
    needConfirm = props.needConfirm;
  var showPanelFooter = enableTimePicker && needConfirm || presets;
  return showPanelFooter ? /* @__PURE__ */React.createElement(DatePickerFooter, {
    presets: presets,
    onPresetClick: onPresetClick,
    enableTimePicker: enableTimePicker,
    onConfirmClick: onConfirmClick,
    presetsPlacement: presetsPlacement,
    selectedValue: selectedValue,
    needConfirm: needConfirm
  }) : null;
}

export { ExtraContent as default };
//# sourceMappingURL=ExtraContent.js.map
