/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../_chunks/dep-c4282af8.js';
import { useState, useEffect } from 'react';
import '../_chunks/dep-ecbbcdbe.js';
import { h as getFileUrlByFileRaw } from '../_chunks/dep-c488a23e.js';
import { l as log } from '../_chunks/dep-653e29e9.js';
import '../_chunks/dep-872e77c8.js';

function useImagePreviewUrl(imgUrl) {
  var _useState = useState(""),
    _useState2 = _slicedToArray(_useState, 2),
    previewUrl = _useState2[0],
    setPreviewUrl = _useState2[1];
  useEffect(function () {
    if (!imgUrl) return;
    if (typeof imgUrl === "string") {
      setPreviewUrl(imgUrl);
      return;
    }
    getFileUrlByFileRaw(imgUrl).then(function (url) {
      setPreviewUrl(url);
    }, function () {
      log.error("Image", "Image.src is not a valid file");
    });
  }, [imgUrl]);
  return {
    previewUrl: previewUrl
  };
}

export { useImagePreviewUrl as default, useImagePreviewUrl };
//# sourceMappingURL=useImagePreviewUrl.js.map
