/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { isObject } from 'lodash-es';
import dayjs from 'dayjs';
import { j as isEnabledDate } from '../../_chunks/dep-b2dad74f.js';
import '../../_chunks/dep-c4282af8.js';
import '../../_chunks/dep-872e77c8.js';
import '../../_chunks/dep-4570e07f.js';
import '../../_chunks/dep-d9ee0736.js';
import '../../_chunks/dep-097b28c0.js';
import '../../_chunks/dep-228a6bad.js';
import '../../_chunks/dep-0dbc2fba.js';
import '../../_chunks/dep-ecbbcdbe.js';
import '../../_chunks/dep-653e29e9.js';

function useDisableDate(props) {
  var _disableDate = props.disableDate,
    format = props.format,
    mode = props.mode,
    start = props.start,
    end = props.end;
  return {
    disableDate: function disableDate(value) {
      return !isEnabledDate({
        disableDate: _disableDate,
        format: format,
        mode: mode,
        value: value
      });
    },
    minDate: isObject(_disableDate) && "before" in _disableDate ? new Date(dayjs(_disableDate.before).startOf("day").format()) : start,
    maxDate: isObject(_disableDate) && "after" in _disableDate ? new Date(dayjs(_disableDate.after).endOf("day").format()) : end
  };
}

export { useDisableDate as default };
//# sourceMappingURL=useDisableDate.js.map
