/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../_chunks/dep-c4282af8.js';
import { useState, useEffect } from 'react';
import { debounce } from 'lodash-es';
import { d as getWindowSize } from '../_chunks/dep-c514bb1c.js';
import '../_chunks/dep-872e77c8.js';

function useWindowSize() {
  var _useState = useState(getWindowSize),
    _useState2 = _slicedToArray(_useState, 2),
    size = _useState2[0],
    setSize = _useState2[1];
  useEffect(function () {
    function handleResize() {
      setSize(getWindowSize());
    }
    var debounceResize = debounce(handleResize, 400);
    window.addEventListener("resize", debounceResize);
    return function () {
      window.removeEventListener("resize", debounceResize);
      debounceResize.cancel();
    };
  }, []);
  return size;
}

export { useWindowSize as default };
//# sourceMappingURL=useWindowSize.js.map
