/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-4570e07f.js';
import React from 'react';
import { pick } from 'lodash-es';
import classNames from 'classnames';
import Panel from './components/Panel.js';
import { useCascaderContext } from './hooks.js';
import { cascaderDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-d9ee0736.js';
import '../_chunks/dep-c4282af8.js';
import '../_chunks/dep-872e77c8.js';
import './components/Item.js';
import 'tdesign-icons-react';
import '../loading/index.js';
import '../loading/Loading.js';
import '../_chunks/dep-c514bb1c.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-2fbc3a66.js';
import '../_chunks/dep-2afb2ca1.js';
import 'dayjs';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-f0b5ab03.js';
import '../_chunks/dep-fe92fe97.js';
import '../_chunks/dep-759f5bcf.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-d0df0249.js';
import '../common/PluginContainer.js';
import '../config-provider/ConfigProvider.js';
import '../checkbox/index.js';
import '../_chunks/dep-5a2a1359.js';
import '../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../common/Check.js';
import '../_chunks/dep-f20b5e73.js';
import '../_util/helper.js';
import '../hooks/useControlled.js';
import '../_util/noop.js';
import '../checkbox/defaultProps.js';
import '../hooks/useGlobalIcon.js';
import '../hooks/useCommonClassName.js';
import './core/helper.js';
import './core/className.js';
import '../locale/LocalReceiver.js';
import './core/effect.js';
import '../_util/parseTNode.js';
import '../_chunks/dep-653e29e9.js';
import '../_chunks/dep-150f208c.js';
import '../_chunks/dep-b165036d.js';
import 'mitt';
import '../_chunks/dep-acd02333.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CascaderPanel = function CascaderPanel(originalProps) {
  var props = useDefaultProps(originalProps, cascaderDefaultProps);
  var _useCascaderContext = useCascaderContext(props),
    cascaderContext = _useCascaderContext.cascaderContext;
  return /* @__PURE__ */React.createElement(Panel, _objectSpread({
    className: classNames(props.className),
    style: props.style,
    cascaderContext: cascaderContext
  }, pick(props, ["trigger", "onChange", "empty", "option"])));
};
CascaderPanel.displayName = "CascaderPanel";

export { CascaderPanel as default };
//# sourceMappingURL=CascaderPanel.js.map
