/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-4570e07f.js';
import React from 'react';
import ColorPanel from './components/panel/index.js';
import '../_chunks/dep-d9ee0736.js';
import '../_chunks/dep-759f5bcf.js';
import '../_chunks/dep-872e77c8.js';
import '../_chunks/dep-c4282af8.js';
import 'classnames';
import '../_chunks/dep-10322410.js';
import '../_chunks/dep-b165036d.js';
import 'tinycolor2';
import '../_chunks/dep-ce4283d9.js';
import 'lodash-es';
import '../_chunks/dep-07e349f8.js';
import '../input/index.js';
import '../input/Input.js';
import '../_chunks/dep-f20b5e73.js';
import 'tdesign-icons-react';
import '../hooks/useLayoutEffect.js';
import '../_chunks/dep-c514bb1c.js';
import '../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-2fbc3a66.js';
import '../_chunks/dep-2afb2ca1.js';
import 'dayjs';
import '../hooks/useGlobalIcon.js';
import '../input/InputGroup.js';
import '../hooks/useControlled.js';
import '../_util/noop.js';
import '../locale/LocalReceiver.js';
import '../config-provider/ConfigProvider.js';
import '../input/defaultProps.js';
import '../_util/parseTNode.js';
import '../_chunks/dep-653e29e9.js';
import '../input/useLengthLimit.js';
import '../_chunks/dep-fe92fe97.js';
import '../hooks/useDefaultProps.js';
import '../input-number/index.js';
import '../input-number/InputNumber.js';
import '../button/index.js';
import '../button/Button.js';
import '../hooks/useDomRefCallback.js';
import '../hooks/useRipple.js';
import '../_chunks/dep-f0b5ab03.js';
import '../hooks/useAnimation.js';
import '../loading/index.js';
import '../loading/Loading.js';
import '../common/Portal.js';
import 'react-dom';
import '../loading/gradient.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-d0df0249.js';
import '../common/PluginContainer.js';
import '../button/defaultProps.js';
import '../input-number/useInputNumber.js';
import '../_chunks/dep-f6ce4770.js';
import '../hooks/useCommonClassName.js';
import '../input-number/defaultProps.js';
import './hooks/useClassNames.js';
import './defaultProps.js';
import './components/panel/linear-gradient.js';
import './components/panel/saturation.js';
import '../hooks/useDrag.js';
import './components/panel/hue.js';
import './components/panel/slider.js';
import './hooks/useStyles.js';
import './components/panel/alpha.js';
import './components/panel/format/index.js';
import '../select/index.js';
import '../select/base/Select.js';
import '../_util/helper.js';
import '../select/util/helper.js';
import '../select/base/OptionGroup.js';
import '../select/defaultProps.js';
import '../select/base/Option.js';
import '../common/FakeArrow.js';
import '../select-input/index.js';
import '../select-input/SelectInput.js';
import '../popup/index.js';
import '../popup/Popup.js';
import 'react-transition-group';
import '../popup/hooks/useTrigger.js';
import 'react-is';
import '../_util/ref.js';
import '../_util/isFragment.js';
import '../_util/composeRefs.js';
import '../_util/listener.js';
import '../popup/utils/transition.js';
import '../hooks/useMutationObserver.js';
import '../hooks/useLatest.js';
import '../hooks/useWindowSize.js';
import '../popup/defaultProps.js';
import '../hooks/useAttach.js';
import '../hooks/usePopper.js';
import '@popperjs/core';
import 'react-fast-compare';
import '../popup/PopupPlugin.js';
import '../select-input/useSingle.js';
import '../select-input/useMultiple.js';
import '../tag-input/index.js';
import '../tag-input/TagInput.js';
import '../hooks/useDragSorter.js';
import '../hooks/useEventCallback.js';
import '../tag-input/useTagScroll.js';
import '../tag-input/useTagList.js';
import '../tag/index.js';
import '../tag/Tag.js';
import '../tag/defaultProps.js';
import '../tag/CheckTag.js';
import '../_chunks/dep-2c6f8d8e.js';
import '../tag/CheckTagGroup.js';
import '../tag-input/useHover.js';
import '../tag-input/defaultProps.js';
import '../select-input/useOverlayInnerStyle.js';
import '../select-input/defaultProps.js';
import '../select/base/PopupContent.js';
import '../select/hooks/usePanelVirtualScroll.js';
import '../hooks/useVirtualScroll.js';
import '../hooks/useResizeObserver.js';
import '../select/hooks/useOptions.js';
import './components/panel/header.js';
import '../radio/index.js';
import '../_chunks/dep-18d034dd.js';
import '../common/Check.js';
import '../_chunks/dep-455833d0.js';
import '../radio/defaultProps.js';
import '../radio/useKeyboard.js';
import './components/panel/swatches.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ColorPickerPanel = function ColorPickerPanel(props) {
  return /* @__PURE__ */React.createElement(ColorPanel, _objectSpread(_objectSpread({}, props), {}, {
    popupProps: null
  }));
};
ColorPickerPanel.displayName = "ColorPickerPanel";
var _ColorPickerPanel = /*#__PURE__*/React.memo(ColorPickerPanel);

export { _ColorPickerPanel as default };
//# sourceMappingURL=ColorPickerPanel.js.map
