/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import classNames from 'classnames';
import useConfig from '../hooks/useConfig.js';
import { cacularPaddingLeft } from './_util/cacularPaddingLeft.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-4570e07f.js';
import '../_chunks/dep-d9ee0736.js';
import 'lodash-es';
import '../_chunks/dep-2fbc3a66.js';
import '../_chunks/dep-2afb2ca1.js';
import 'dayjs';

var MenuGroup = function MenuGroup(_ref) {
  var title = _ref.title,
    className = _ref.className,
    style = _ref.style,
    children = _ref.children,
    _ref$level = _ref.level,
    level = _ref$level === void 0 ? 1 : _ref$level;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var itemAndGroupPaddingBias = 28;
  var menuPaddingLeft = cacularPaddingLeft(level - 1) - itemAndGroupPaddingBias;
  return /* @__PURE__ */React.createElement("div", {
    className: classNames(className, "".concat(classPrefix, "-menu-group")),
    style: style
  }, /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(classPrefix, "-menu-group__title")),
    style: {
      paddingLeft: "".concat(menuPaddingLeft, "px")
    }
  }, title), children);
};
MenuGroup.displayName = "MenuGroup";

export { MenuGroup as default };
//# sourceMappingURL=MenuGroup.js.map
