/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import { CheckCircleFilledIcon, ErrorCircleFilledIcon, HelpCircleFilledIcon, InfoCircleFilledIcon } from 'tdesign-icons-react';
import useGlobalIcon from '../hooks/useGlobalIcon.js';
import { Loading } from '../loading/index.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-4570e07f.js';
import '../_chunks/dep-d9ee0736.js';
import 'lodash-es';
import '../_chunks/dep-2fbc3a66.js';
import '../_chunks/dep-2afb2ca1.js';
import 'dayjs';
import '../loading/Loading.js';
import '../_chunks/dep-c4282af8.js';
import '../_chunks/dep-872e77c8.js';
import 'classnames';
import '../_chunks/dep-c514bb1c.js';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-f0b5ab03.js';
import '../_chunks/dep-fe92fe97.js';
import '../_chunks/dep-759f5bcf.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-d0df0249.js';
import '../common/PluginContainer.js';
import '../config-provider/ConfigProvider.js';

function MessageIcon(_ref) {
  var theme = _ref.theme,
    onCloseBtnClick = _ref.onCloseBtnClick;
  var _useGlobalIcon = useGlobalIcon({
      CheckCircleFilledIcon: CheckCircleFilledIcon,
      ErrorCircleFilledIcon: ErrorCircleFilledIcon,
      HelpCircleFilledIcon: HelpCircleFilledIcon,
      InfoCircleFilledIcon: InfoCircleFilledIcon
    }),
    CheckCircleFilledIcon$1 = _useGlobalIcon.CheckCircleFilledIcon,
    ErrorCircleFilledIcon$1 = _useGlobalIcon.ErrorCircleFilledIcon,
    HelpCircleFilledIcon$1 = _useGlobalIcon.HelpCircleFilledIcon,
    InfoCircleFilledIcon$1 = _useGlobalIcon.InfoCircleFilledIcon;
  var iconMap = {
    info: InfoCircleFilledIcon$1,
    success: CheckCircleFilledIcon$1,
    warning: ErrorCircleFilledIcon$1,
    error: ErrorCircleFilledIcon$1,
    question: HelpCircleFilledIcon$1,
    loading: Loading
  };
  var Icon = iconMap[theme];
  if (theme === "loading") {
    return /* @__PURE__ */React.createElement(Icon, {
      loading: true
    });
  }
  return Icon ? /* @__PURE__ */React.createElement(Icon, {
    onClick: function onClick(e) {
      return onCloseBtnClick === null || onCloseBtnClick === void 0 ? void 0 : onCloseBtnClick({
        e: e
      });
    }
  }) : null;
}

export { MessageIcon as default };
//# sourceMappingURL=MessageIcon.js.map
