/**
 * tdesign v1.12.2
 * (c) 2025 tdesign
 * @license MIT
 */

import useConfig from '../hooks/useConfig.js';
import 'react';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-4570e07f.js';
import '../_chunks/dep-d9ee0736.js';
import 'lodash-es';
import '../_chunks/dep-2fbc3a66.js';
import '../_chunks/dep-2afb2ca1.js';
import 'dayjs';

function useMessageClass() {
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var tdMessagePrefix = "".concat(classPrefix, "-message");
  var tdMessageListClass = "".concat(tdMessagePrefix, "__list");
  var tdClassIsGenerator = function tdClassIsGenerator(append) {
    return "".concat(classPrefix, "-is-").concat(append);
  };
  var tdMessageClassGenerator = function tdMessageClassGenerator(append) {
    return "".concat(tdMessagePrefix, "__").concat(append);
  };
  var tdMessagePlacementClassGenerator = function tdMessagePlacementClassGenerator(placement) {
    return "".concat(tdMessagePrefix, "-placement--").concat(placement);
  };
  return {
    tdMessagePrefix: tdMessagePrefix,
    tdMessageListClass: tdMessageListClass,
    tdClassIsGenerator: tdClassIsGenerator,
    tdMessageClassGenerator: tdMessageClassGenerator,
    tdMessagePlacementClassGenerator: tdMessagePlacementClassGenerator
  };
}

export { useMessageClass };
//# sourceMappingURL=useMessageClass.js.map
